package hu.bme.mit.ui.contentassist.antlr.internal; 

import java.io.InputStream;
import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.xtext.parsetree.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.ui.editor.contentassist.antlr.internal.AbstractInternalContentAssistParser;
import org.eclipse.xtext.ui.editor.contentassist.antlr.internal.DFA;
import hu.bme.mit.services.SocialnetworkGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalSocialnetworkParser extends AbstractInternalContentAssistParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_ID", "RULE_INT", "RULE_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'friend of'", "'married to'", "'male'", "'female'", "'SocialNetwork'", "'{'", "'}'", "'is'", "'Person'", "'memberships'", "','", "'Community'"
    };
    public static final int RULE_ID=4;
    public static final int RULE_STRING=6;
    public static final int RULE_ANY_OTHER=10;
    public static final int RULE_INT=5;
    public static final int RULE_WS=9;
    public static final int RULE_SL_COMMENT=8;
    public static final int EOF=-1;
    public static final int RULE_ML_COMMENT=7;

        public InternalSocialnetworkParser(TokenStream input) {
            super(input);
        }
        

    public String[] getTokenNames() { return tokenNames; }
    public String getGrammarFileName() { return "../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g"; }


     
     	private SocialnetworkGrammarAccess grammarAccess;
     	
        public void setGrammarAccess(SocialnetworkGrammarAccess grammarAccess) {
        	this.grammarAccess = grammarAccess;
        }
        
        @Override
        protected Grammar getGrammar() {
        	return grammarAccess.getGrammar();
        }
        
        @Override
        protected String getValueForTokenName(String tokenName) {
        	return tokenName;
        }




    // $ANTLR start entryRuleSocialNetwork
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:61:1: entryRuleSocialNetwork : ruleSocialNetwork EOF ;
    public final void entryRuleSocialNetwork() throws RecognitionException {
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:62:1: ( ruleSocialNetwork EOF )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:63:1: ruleSocialNetwork EOF
            {
             before(grammarAccess.getSocialNetworkRule()); 
            pushFollow(FOLLOW_ruleSocialNetwork_in_entryRuleSocialNetwork61);
            ruleSocialNetwork();
            _fsp--;

             after(grammarAccess.getSocialNetworkRule()); 
            match(input,EOF,FOLLOW_EOF_in_entryRuleSocialNetwork68); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end entryRuleSocialNetwork


    // $ANTLR start ruleSocialNetwork
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:70:1: ruleSocialNetwork : ( ( rule__SocialNetwork__Group__0 ) ) ;
    public final void ruleSocialNetwork() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:74:2: ( ( ( rule__SocialNetwork__Group__0 ) ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:75:1: ( ( rule__SocialNetwork__Group__0 ) )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:75:1: ( ( rule__SocialNetwork__Group__0 ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:76:1: ( rule__SocialNetwork__Group__0 )
            {
             before(grammarAccess.getSocialNetworkAccess().getGroup()); 
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:77:1: ( rule__SocialNetwork__Group__0 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:77:2: rule__SocialNetwork__Group__0
            {
            pushFollow(FOLLOW_rule__SocialNetwork__Group__0_in_ruleSocialNetwork94);
            rule__SocialNetwork__Group__0();
            _fsp--;


            }

             after(grammarAccess.getSocialNetworkAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end ruleSocialNetwork


    // $ANTLR start entryRuleSocialEntity
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:89:1: entryRuleSocialEntity : ruleSocialEntity EOF ;
    public final void entryRuleSocialEntity() throws RecognitionException {
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:90:1: ( ruleSocialEntity EOF )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:91:1: ruleSocialEntity EOF
            {
             before(grammarAccess.getSocialEntityRule()); 
            pushFollow(FOLLOW_ruleSocialEntity_in_entryRuleSocialEntity121);
            ruleSocialEntity();
            _fsp--;

             after(grammarAccess.getSocialEntityRule()); 
            match(input,EOF,FOLLOW_EOF_in_entryRuleSocialEntity128); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end entryRuleSocialEntity


    // $ANTLR start ruleSocialEntity
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:98:1: ruleSocialEntity : ( ( rule__SocialEntity__Alternatives ) ) ;
    public final void ruleSocialEntity() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:102:2: ( ( ( rule__SocialEntity__Alternatives ) ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:103:1: ( ( rule__SocialEntity__Alternatives ) )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:103:1: ( ( rule__SocialEntity__Alternatives ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:104:1: ( rule__SocialEntity__Alternatives )
            {
             before(grammarAccess.getSocialEntityAccess().getAlternatives()); 
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:105:1: ( rule__SocialEntity__Alternatives )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:105:2: rule__SocialEntity__Alternatives
            {
            pushFollow(FOLLOW_rule__SocialEntity__Alternatives_in_ruleSocialEntity154);
            rule__SocialEntity__Alternatives();
            _fsp--;


            }

             after(grammarAccess.getSocialEntityAccess().getAlternatives()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end ruleSocialEntity


    // $ANTLR start entryRuleAquaintance
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:117:1: entryRuleAquaintance : ruleAquaintance EOF ;
    public final void entryRuleAquaintance() throws RecognitionException {
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:118:1: ( ruleAquaintance EOF )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:119:1: ruleAquaintance EOF
            {
             before(grammarAccess.getAquaintanceRule()); 
            pushFollow(FOLLOW_ruleAquaintance_in_entryRuleAquaintance181);
            ruleAquaintance();
            _fsp--;

             after(grammarAccess.getAquaintanceRule()); 
            match(input,EOF,FOLLOW_EOF_in_entryRuleAquaintance188); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end entryRuleAquaintance


    // $ANTLR start ruleAquaintance
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:126:1: ruleAquaintance : ( ( rule__Aquaintance__Group__0 ) ) ;
    public final void ruleAquaintance() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:130:2: ( ( ( rule__Aquaintance__Group__0 ) ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:131:1: ( ( rule__Aquaintance__Group__0 ) )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:131:1: ( ( rule__Aquaintance__Group__0 ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:132:1: ( rule__Aquaintance__Group__0 )
            {
             before(grammarAccess.getAquaintanceAccess().getGroup()); 
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:133:1: ( rule__Aquaintance__Group__0 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:133:2: rule__Aquaintance__Group__0
            {
            pushFollow(FOLLOW_rule__Aquaintance__Group__0_in_ruleAquaintance214);
            rule__Aquaintance__Group__0();
            _fsp--;


            }

             after(grammarAccess.getAquaintanceAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end ruleAquaintance


    // $ANTLR start entryRulePerson
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:145:1: entryRulePerson : rulePerson EOF ;
    public final void entryRulePerson() throws RecognitionException {
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:146:1: ( rulePerson EOF )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:147:1: rulePerson EOF
            {
             before(grammarAccess.getPersonRule()); 
            pushFollow(FOLLOW_rulePerson_in_entryRulePerson241);
            rulePerson();
            _fsp--;

             after(grammarAccess.getPersonRule()); 
            match(input,EOF,FOLLOW_EOF_in_entryRulePerson248); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end entryRulePerson


    // $ANTLR start rulePerson
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:154:1: rulePerson : ( ( rule__Person__Group__0 ) ) ;
    public final void rulePerson() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:158:2: ( ( ( rule__Person__Group__0 ) ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:159:1: ( ( rule__Person__Group__0 ) )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:159:1: ( ( rule__Person__Group__0 ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:160:1: ( rule__Person__Group__0 )
            {
             before(grammarAccess.getPersonAccess().getGroup()); 
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:161:1: ( rule__Person__Group__0 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:161:2: rule__Person__Group__0
            {
            pushFollow(FOLLOW_rule__Person__Group__0_in_rulePerson274);
            rule__Person__Group__0();
            _fsp--;


            }

             after(grammarAccess.getPersonAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rulePerson


    // $ANTLR start entryRuleCommunity
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:173:1: entryRuleCommunity : ruleCommunity EOF ;
    public final void entryRuleCommunity() throws RecognitionException {
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:174:1: ( ruleCommunity EOF )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:175:1: ruleCommunity EOF
            {
             before(grammarAccess.getCommunityRule()); 
            pushFollow(FOLLOW_ruleCommunity_in_entryRuleCommunity301);
            ruleCommunity();
            _fsp--;

             after(grammarAccess.getCommunityRule()); 
            match(input,EOF,FOLLOW_EOF_in_entryRuleCommunity308); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end entryRuleCommunity


    // $ANTLR start ruleCommunity
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:182:1: ruleCommunity : ( ( rule__Community__Group__0 ) ) ;
    public final void ruleCommunity() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:186:2: ( ( ( rule__Community__Group__0 ) ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:187:1: ( ( rule__Community__Group__0 ) )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:187:1: ( ( rule__Community__Group__0 ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:188:1: ( rule__Community__Group__0 )
            {
             before(grammarAccess.getCommunityAccess().getGroup()); 
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:189:1: ( rule__Community__Group__0 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:189:2: rule__Community__Group__0
            {
            pushFollow(FOLLOW_rule__Community__Group__0_in_ruleCommunity334);
            rule__Community__Group__0();
            _fsp--;


            }

             after(grammarAccess.getCommunityAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end ruleCommunity


    // $ANTLR start ruleAquaintanceType
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:202:1: ruleAquaintanceType : ( ( rule__AquaintanceType__Alternatives ) ) ;
    public final void ruleAquaintanceType() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:206:1: ( ( ( rule__AquaintanceType__Alternatives ) ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:207:1: ( ( rule__AquaintanceType__Alternatives ) )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:207:1: ( ( rule__AquaintanceType__Alternatives ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:208:1: ( rule__AquaintanceType__Alternatives )
            {
             before(grammarAccess.getAquaintanceTypeAccess().getAlternatives()); 
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:209:1: ( rule__AquaintanceType__Alternatives )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:209:2: rule__AquaintanceType__Alternatives
            {
            pushFollow(FOLLOW_rule__AquaintanceType__Alternatives_in_ruleAquaintanceType371);
            rule__AquaintanceType__Alternatives();
            _fsp--;


            }

             after(grammarAccess.getAquaintanceTypeAccess().getAlternatives()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end ruleAquaintanceType


    // $ANTLR start ruleSex
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:221:1: ruleSex : ( ( rule__Sex__Alternatives ) ) ;
    public final void ruleSex() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:225:1: ( ( ( rule__Sex__Alternatives ) ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:226:1: ( ( rule__Sex__Alternatives ) )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:226:1: ( ( rule__Sex__Alternatives ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:227:1: ( rule__Sex__Alternatives )
            {
             before(grammarAccess.getSexAccess().getAlternatives()); 
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:228:1: ( rule__Sex__Alternatives )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:228:2: rule__Sex__Alternatives
            {
            pushFollow(FOLLOW_rule__Sex__Alternatives_in_ruleSex407);
            rule__Sex__Alternatives();
            _fsp--;


            }

             after(grammarAccess.getSexAccess().getAlternatives()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end ruleSex


    // $ANTLR start rule__SocialEntity__Alternatives
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:239:1: rule__SocialEntity__Alternatives : ( ( rulePerson ) | ( ruleCommunity ) );
    public final void rule__SocialEntity__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:243:1: ( ( rulePerson ) | ( ruleCommunity ) )
            int alt1=2;
            int LA1_0 = input.LA(1);

            if ( (LA1_0==19) ) {
                alt1=1;
            }
            else if ( (LA1_0==22) ) {
                alt1=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("239:1: rule__SocialEntity__Alternatives : ( ( rulePerson ) | ( ruleCommunity ) );", 1, 0, input);

                throw nvae;
            }
            switch (alt1) {
                case 1 :
                    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:244:1: ( rulePerson )
                    {
                    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:244:1: ( rulePerson )
                    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:245:1: rulePerson
                    {
                     before(grammarAccess.getSocialEntityAccess().getPersonParserRuleCall_0()); 
                    pushFollow(FOLLOW_rulePerson_in_rule__SocialEntity__Alternatives442);
                    rulePerson();
                    _fsp--;

                     after(grammarAccess.getSocialEntityAccess().getPersonParserRuleCall_0()); 

                    }


                    }
                    break;
                case 2 :
                    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:250:6: ( ruleCommunity )
                    {
                    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:250:6: ( ruleCommunity )
                    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:251:1: ruleCommunity
                    {
                     before(grammarAccess.getSocialEntityAccess().getCommunityParserRuleCall_1()); 
                    pushFollow(FOLLOW_ruleCommunity_in_rule__SocialEntity__Alternatives459);
                    ruleCommunity();
                    _fsp--;

                     after(grammarAccess.getSocialEntityAccess().getCommunityParserRuleCall_1()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__SocialEntity__Alternatives


    // $ANTLR start rule__AquaintanceType__Alternatives
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:261:1: rule__AquaintanceType__Alternatives : ( ( ( 'friend of' ) ) | ( ( 'married to' ) ) );
    public final void rule__AquaintanceType__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:265:1: ( ( ( 'friend of' ) ) | ( ( 'married to' ) ) )
            int alt2=2;
            int LA2_0 = input.LA(1);

            if ( (LA2_0==11) ) {
                alt2=1;
            }
            else if ( (LA2_0==12) ) {
                alt2=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("261:1: rule__AquaintanceType__Alternatives : ( ( ( 'friend of' ) ) | ( ( 'married to' ) ) );", 2, 0, input);

                throw nvae;
            }
            switch (alt2) {
                case 1 :
                    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:266:1: ( ( 'friend of' ) )
                    {
                    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:266:1: ( ( 'friend of' ) )
                    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:267:1: ( 'friend of' )
                    {
                     before(grammarAccess.getAquaintanceTypeAccess().getFriendshipEnumLiteralDeclaration_0()); 
                    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:268:1: ( 'friend of' )
                    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:268:3: 'friend of'
                    {
                    match(input,11,FOLLOW_11_in_rule__AquaintanceType__Alternatives492); 

                    }

                     after(grammarAccess.getAquaintanceTypeAccess().getFriendshipEnumLiteralDeclaration_0()); 

                    }


                    }
                    break;
                case 2 :
                    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:273:6: ( ( 'married to' ) )
                    {
                    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:273:6: ( ( 'married to' ) )
                    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:274:1: ( 'married to' )
                    {
                     before(grammarAccess.getAquaintanceTypeAccess().getMarriageEnumLiteralDeclaration_1()); 
                    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:275:1: ( 'married to' )
                    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:275:3: 'married to'
                    {
                    match(input,12,FOLLOW_12_in_rule__AquaintanceType__Alternatives513); 

                    }

                     after(grammarAccess.getAquaintanceTypeAccess().getMarriageEnumLiteralDeclaration_1()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__AquaintanceType__Alternatives


    // $ANTLR start rule__Sex__Alternatives
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:285:1: rule__Sex__Alternatives : ( ( ( 'male' ) ) | ( ( 'female' ) ) );
    public final void rule__Sex__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:289:1: ( ( ( 'male' ) ) | ( ( 'female' ) ) )
            int alt3=2;
            int LA3_0 = input.LA(1);

            if ( (LA3_0==13) ) {
                alt3=1;
            }
            else if ( (LA3_0==14) ) {
                alt3=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("285:1: rule__Sex__Alternatives : ( ( ( 'male' ) ) | ( ( 'female' ) ) );", 3, 0, input);

                throw nvae;
            }
            switch (alt3) {
                case 1 :
                    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:290:1: ( ( 'male' ) )
                    {
                    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:290:1: ( ( 'male' ) )
                    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:291:1: ( 'male' )
                    {
                     before(grammarAccess.getSexAccess().getMaleEnumLiteralDeclaration_0()); 
                    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:292:1: ( 'male' )
                    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:292:3: 'male'
                    {
                    match(input,13,FOLLOW_13_in_rule__Sex__Alternatives549); 

                    }

                     after(grammarAccess.getSexAccess().getMaleEnumLiteralDeclaration_0()); 

                    }


                    }
                    break;
                case 2 :
                    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:297:6: ( ( 'female' ) )
                    {
                    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:297:6: ( ( 'female' ) )
                    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:298:1: ( 'female' )
                    {
                     before(grammarAccess.getSexAccess().getFemaleEnumLiteralDeclaration_1()); 
                    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:299:1: ( 'female' )
                    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:299:3: 'female'
                    {
                    match(input,14,FOLLOW_14_in_rule__Sex__Alternatives570); 

                    }

                     after(grammarAccess.getSexAccess().getFemaleEnumLiteralDeclaration_1()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Sex__Alternatives


    // $ANTLR start rule__SocialNetwork__Group__0
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:311:1: rule__SocialNetwork__Group__0 : rule__SocialNetwork__Group__0__Impl rule__SocialNetwork__Group__1 ;
    public final void rule__SocialNetwork__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:315:1: ( rule__SocialNetwork__Group__0__Impl rule__SocialNetwork__Group__1 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:316:2: rule__SocialNetwork__Group__0__Impl rule__SocialNetwork__Group__1
            {
            pushFollow(FOLLOW_rule__SocialNetwork__Group__0__Impl_in_rule__SocialNetwork__Group__0603);
            rule__SocialNetwork__Group__0__Impl();
            _fsp--;

            pushFollow(FOLLOW_rule__SocialNetwork__Group__1_in_rule__SocialNetwork__Group__0606);
            rule__SocialNetwork__Group__1();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__SocialNetwork__Group__0


    // $ANTLR start rule__SocialNetwork__Group__0__Impl
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:323:1: rule__SocialNetwork__Group__0__Impl : ( 'SocialNetwork' ) ;
    public final void rule__SocialNetwork__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:327:1: ( ( 'SocialNetwork' ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:328:1: ( 'SocialNetwork' )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:328:1: ( 'SocialNetwork' )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:329:1: 'SocialNetwork'
            {
             before(grammarAccess.getSocialNetworkAccess().getSocialNetworkKeyword_0()); 
            match(input,15,FOLLOW_15_in_rule__SocialNetwork__Group__0__Impl634); 
             after(grammarAccess.getSocialNetworkAccess().getSocialNetworkKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__SocialNetwork__Group__0__Impl


    // $ANTLR start rule__SocialNetwork__Group__1
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:342:1: rule__SocialNetwork__Group__1 : rule__SocialNetwork__Group__1__Impl rule__SocialNetwork__Group__2 ;
    public final void rule__SocialNetwork__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:346:1: ( rule__SocialNetwork__Group__1__Impl rule__SocialNetwork__Group__2 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:347:2: rule__SocialNetwork__Group__1__Impl rule__SocialNetwork__Group__2
            {
            pushFollow(FOLLOW_rule__SocialNetwork__Group__1__Impl_in_rule__SocialNetwork__Group__1665);
            rule__SocialNetwork__Group__1__Impl();
            _fsp--;

            pushFollow(FOLLOW_rule__SocialNetwork__Group__2_in_rule__SocialNetwork__Group__1668);
            rule__SocialNetwork__Group__2();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__SocialNetwork__Group__1


    // $ANTLR start rule__SocialNetwork__Group__1__Impl
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:354:1: rule__SocialNetwork__Group__1__Impl : ( '{' ) ;
    public final void rule__SocialNetwork__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:358:1: ( ( '{' ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:359:1: ( '{' )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:359:1: ( '{' )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:360:1: '{'
            {
             before(grammarAccess.getSocialNetworkAccess().getLeftCurlyBracketKeyword_1()); 
            match(input,16,FOLLOW_16_in_rule__SocialNetwork__Group__1__Impl696); 
             after(grammarAccess.getSocialNetworkAccess().getLeftCurlyBracketKeyword_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__SocialNetwork__Group__1__Impl


    // $ANTLR start rule__SocialNetwork__Group__2
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:373:1: rule__SocialNetwork__Group__2 : rule__SocialNetwork__Group__2__Impl rule__SocialNetwork__Group__3 ;
    public final void rule__SocialNetwork__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:377:1: ( rule__SocialNetwork__Group__2__Impl rule__SocialNetwork__Group__3 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:378:2: rule__SocialNetwork__Group__2__Impl rule__SocialNetwork__Group__3
            {
            pushFollow(FOLLOW_rule__SocialNetwork__Group__2__Impl_in_rule__SocialNetwork__Group__2727);
            rule__SocialNetwork__Group__2__Impl();
            _fsp--;

            pushFollow(FOLLOW_rule__SocialNetwork__Group__3_in_rule__SocialNetwork__Group__2730);
            rule__SocialNetwork__Group__3();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__SocialNetwork__Group__2


    // $ANTLR start rule__SocialNetwork__Group__2__Impl
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:385:1: rule__SocialNetwork__Group__2__Impl : ( ( rule__SocialNetwork__EntitiesAssignment_2 )* ) ;
    public final void rule__SocialNetwork__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:389:1: ( ( ( rule__SocialNetwork__EntitiesAssignment_2 )* ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:390:1: ( ( rule__SocialNetwork__EntitiesAssignment_2 )* )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:390:1: ( ( rule__SocialNetwork__EntitiesAssignment_2 )* )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:391:1: ( rule__SocialNetwork__EntitiesAssignment_2 )*
            {
             before(grammarAccess.getSocialNetworkAccess().getEntitiesAssignment_2()); 
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:392:1: ( rule__SocialNetwork__EntitiesAssignment_2 )*
            loop4:
            do {
                int alt4=2;
                int LA4_0 = input.LA(1);

                if ( (LA4_0==19||LA4_0==22) ) {
                    alt4=1;
                }


                switch (alt4) {
            	case 1 :
            	    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:392:2: rule__SocialNetwork__EntitiesAssignment_2
            	    {
            	    pushFollow(FOLLOW_rule__SocialNetwork__EntitiesAssignment_2_in_rule__SocialNetwork__Group__2__Impl757);
            	    rule__SocialNetwork__EntitiesAssignment_2();
            	    _fsp--;


            	    }
            	    break;

            	default :
            	    break loop4;
                }
            } while (true);

             after(grammarAccess.getSocialNetworkAccess().getEntitiesAssignment_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__SocialNetwork__Group__2__Impl


    // $ANTLR start rule__SocialNetwork__Group__3
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:402:1: rule__SocialNetwork__Group__3 : rule__SocialNetwork__Group__3__Impl rule__SocialNetwork__Group__4 ;
    public final void rule__SocialNetwork__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:406:1: ( rule__SocialNetwork__Group__3__Impl rule__SocialNetwork__Group__4 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:407:2: rule__SocialNetwork__Group__3__Impl rule__SocialNetwork__Group__4
            {
            pushFollow(FOLLOW_rule__SocialNetwork__Group__3__Impl_in_rule__SocialNetwork__Group__3788);
            rule__SocialNetwork__Group__3__Impl();
            _fsp--;

            pushFollow(FOLLOW_rule__SocialNetwork__Group__4_in_rule__SocialNetwork__Group__3791);
            rule__SocialNetwork__Group__4();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__SocialNetwork__Group__3


    // $ANTLR start rule__SocialNetwork__Group__3__Impl
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:414:1: rule__SocialNetwork__Group__3__Impl : ( ( rule__SocialNetwork__AquaintancesAssignment_3 )* ) ;
    public final void rule__SocialNetwork__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:418:1: ( ( ( rule__SocialNetwork__AquaintancesAssignment_3 )* ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:419:1: ( ( rule__SocialNetwork__AquaintancesAssignment_3 )* )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:419:1: ( ( rule__SocialNetwork__AquaintancesAssignment_3 )* )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:420:1: ( rule__SocialNetwork__AquaintancesAssignment_3 )*
            {
             before(grammarAccess.getSocialNetworkAccess().getAquaintancesAssignment_3()); 
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:421:1: ( rule__SocialNetwork__AquaintancesAssignment_3 )*
            loop5:
            do {
                int alt5=2;
                int LA5_0 = input.LA(1);

                if ( (LA5_0==RULE_ID) ) {
                    alt5=1;
                }


                switch (alt5) {
            	case 1 :
            	    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:421:2: rule__SocialNetwork__AquaintancesAssignment_3
            	    {
            	    pushFollow(FOLLOW_rule__SocialNetwork__AquaintancesAssignment_3_in_rule__SocialNetwork__Group__3__Impl818);
            	    rule__SocialNetwork__AquaintancesAssignment_3();
            	    _fsp--;


            	    }
            	    break;

            	default :
            	    break loop5;
                }
            } while (true);

             after(grammarAccess.getSocialNetworkAccess().getAquaintancesAssignment_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__SocialNetwork__Group__3__Impl


    // $ANTLR start rule__SocialNetwork__Group__4
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:431:1: rule__SocialNetwork__Group__4 : rule__SocialNetwork__Group__4__Impl ;
    public final void rule__SocialNetwork__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:435:1: ( rule__SocialNetwork__Group__4__Impl )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:436:2: rule__SocialNetwork__Group__4__Impl
            {
            pushFollow(FOLLOW_rule__SocialNetwork__Group__4__Impl_in_rule__SocialNetwork__Group__4849);
            rule__SocialNetwork__Group__4__Impl();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__SocialNetwork__Group__4


    // $ANTLR start rule__SocialNetwork__Group__4__Impl
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:442:1: rule__SocialNetwork__Group__4__Impl : ( '}' ) ;
    public final void rule__SocialNetwork__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:446:1: ( ( '}' ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:447:1: ( '}' )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:447:1: ( '}' )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:448:1: '}'
            {
             before(grammarAccess.getSocialNetworkAccess().getRightCurlyBracketKeyword_4()); 
            match(input,17,FOLLOW_17_in_rule__SocialNetwork__Group__4__Impl877); 
             after(grammarAccess.getSocialNetworkAccess().getRightCurlyBracketKeyword_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__SocialNetwork__Group__4__Impl


    // $ANTLR start rule__Aquaintance__Group__0
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:471:1: rule__Aquaintance__Group__0 : rule__Aquaintance__Group__0__Impl rule__Aquaintance__Group__1 ;
    public final void rule__Aquaintance__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:475:1: ( rule__Aquaintance__Group__0__Impl rule__Aquaintance__Group__1 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:476:2: rule__Aquaintance__Group__0__Impl rule__Aquaintance__Group__1
            {
            pushFollow(FOLLOW_rule__Aquaintance__Group__0__Impl_in_rule__Aquaintance__Group__0918);
            rule__Aquaintance__Group__0__Impl();
            _fsp--;

            pushFollow(FOLLOW_rule__Aquaintance__Group__1_in_rule__Aquaintance__Group__0921);
            rule__Aquaintance__Group__1();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Aquaintance__Group__0


    // $ANTLR start rule__Aquaintance__Group__0__Impl
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:483:1: rule__Aquaintance__Group__0__Impl : ( ( rule__Aquaintance__SourceAssignment_0 ) ) ;
    public final void rule__Aquaintance__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:487:1: ( ( ( rule__Aquaintance__SourceAssignment_0 ) ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:488:1: ( ( rule__Aquaintance__SourceAssignment_0 ) )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:488:1: ( ( rule__Aquaintance__SourceAssignment_0 ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:489:1: ( rule__Aquaintance__SourceAssignment_0 )
            {
             before(grammarAccess.getAquaintanceAccess().getSourceAssignment_0()); 
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:490:1: ( rule__Aquaintance__SourceAssignment_0 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:490:2: rule__Aquaintance__SourceAssignment_0
            {
            pushFollow(FOLLOW_rule__Aquaintance__SourceAssignment_0_in_rule__Aquaintance__Group__0__Impl948);
            rule__Aquaintance__SourceAssignment_0();
            _fsp--;


            }

             after(grammarAccess.getAquaintanceAccess().getSourceAssignment_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Aquaintance__Group__0__Impl


    // $ANTLR start rule__Aquaintance__Group__1
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:500:1: rule__Aquaintance__Group__1 : rule__Aquaintance__Group__1__Impl rule__Aquaintance__Group__2 ;
    public final void rule__Aquaintance__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:504:1: ( rule__Aquaintance__Group__1__Impl rule__Aquaintance__Group__2 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:505:2: rule__Aquaintance__Group__1__Impl rule__Aquaintance__Group__2
            {
            pushFollow(FOLLOW_rule__Aquaintance__Group__1__Impl_in_rule__Aquaintance__Group__1978);
            rule__Aquaintance__Group__1__Impl();
            _fsp--;

            pushFollow(FOLLOW_rule__Aquaintance__Group__2_in_rule__Aquaintance__Group__1981);
            rule__Aquaintance__Group__2();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Aquaintance__Group__1


    // $ANTLR start rule__Aquaintance__Group__1__Impl
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:512:1: rule__Aquaintance__Group__1__Impl : ( 'is' ) ;
    public final void rule__Aquaintance__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:516:1: ( ( 'is' ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:517:1: ( 'is' )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:517:1: ( 'is' )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:518:1: 'is'
            {
             before(grammarAccess.getAquaintanceAccess().getIsKeyword_1()); 
            match(input,18,FOLLOW_18_in_rule__Aquaintance__Group__1__Impl1009); 
             after(grammarAccess.getAquaintanceAccess().getIsKeyword_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Aquaintance__Group__1__Impl


    // $ANTLR start rule__Aquaintance__Group__2
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:531:1: rule__Aquaintance__Group__2 : rule__Aquaintance__Group__2__Impl rule__Aquaintance__Group__3 ;
    public final void rule__Aquaintance__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:535:1: ( rule__Aquaintance__Group__2__Impl rule__Aquaintance__Group__3 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:536:2: rule__Aquaintance__Group__2__Impl rule__Aquaintance__Group__3
            {
            pushFollow(FOLLOW_rule__Aquaintance__Group__2__Impl_in_rule__Aquaintance__Group__21040);
            rule__Aquaintance__Group__2__Impl();
            _fsp--;

            pushFollow(FOLLOW_rule__Aquaintance__Group__3_in_rule__Aquaintance__Group__21043);
            rule__Aquaintance__Group__3();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Aquaintance__Group__2


    // $ANTLR start rule__Aquaintance__Group__2__Impl
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:543:1: rule__Aquaintance__Group__2__Impl : ( ( rule__Aquaintance__TypeAssignment_2 ) ) ;
    public final void rule__Aquaintance__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:547:1: ( ( ( rule__Aquaintance__TypeAssignment_2 ) ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:548:1: ( ( rule__Aquaintance__TypeAssignment_2 ) )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:548:1: ( ( rule__Aquaintance__TypeAssignment_2 ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:549:1: ( rule__Aquaintance__TypeAssignment_2 )
            {
             before(grammarAccess.getAquaintanceAccess().getTypeAssignment_2()); 
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:550:1: ( rule__Aquaintance__TypeAssignment_2 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:550:2: rule__Aquaintance__TypeAssignment_2
            {
            pushFollow(FOLLOW_rule__Aquaintance__TypeAssignment_2_in_rule__Aquaintance__Group__2__Impl1070);
            rule__Aquaintance__TypeAssignment_2();
            _fsp--;


            }

             after(grammarAccess.getAquaintanceAccess().getTypeAssignment_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Aquaintance__Group__2__Impl


    // $ANTLR start rule__Aquaintance__Group__3
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:560:1: rule__Aquaintance__Group__3 : rule__Aquaintance__Group__3__Impl ;
    public final void rule__Aquaintance__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:564:1: ( rule__Aquaintance__Group__3__Impl )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:565:2: rule__Aquaintance__Group__3__Impl
            {
            pushFollow(FOLLOW_rule__Aquaintance__Group__3__Impl_in_rule__Aquaintance__Group__31100);
            rule__Aquaintance__Group__3__Impl();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Aquaintance__Group__3


    // $ANTLR start rule__Aquaintance__Group__3__Impl
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:571:1: rule__Aquaintance__Group__3__Impl : ( ( rule__Aquaintance__TargetAssignment_3 ) ) ;
    public final void rule__Aquaintance__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:575:1: ( ( ( rule__Aquaintance__TargetAssignment_3 ) ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:576:1: ( ( rule__Aquaintance__TargetAssignment_3 ) )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:576:1: ( ( rule__Aquaintance__TargetAssignment_3 ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:577:1: ( rule__Aquaintance__TargetAssignment_3 )
            {
             before(grammarAccess.getAquaintanceAccess().getTargetAssignment_3()); 
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:578:1: ( rule__Aquaintance__TargetAssignment_3 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:578:2: rule__Aquaintance__TargetAssignment_3
            {
            pushFollow(FOLLOW_rule__Aquaintance__TargetAssignment_3_in_rule__Aquaintance__Group__3__Impl1127);
            rule__Aquaintance__TargetAssignment_3();
            _fsp--;


            }

             after(grammarAccess.getAquaintanceAccess().getTargetAssignment_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Aquaintance__Group__3__Impl


    // $ANTLR start rule__Person__Group__0
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:596:1: rule__Person__Group__0 : rule__Person__Group__0__Impl rule__Person__Group__1 ;
    public final void rule__Person__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:600:1: ( rule__Person__Group__0__Impl rule__Person__Group__1 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:601:2: rule__Person__Group__0__Impl rule__Person__Group__1
            {
            pushFollow(FOLLOW_rule__Person__Group__0__Impl_in_rule__Person__Group__01165);
            rule__Person__Group__0__Impl();
            _fsp--;

            pushFollow(FOLLOW_rule__Person__Group__1_in_rule__Person__Group__01168);
            rule__Person__Group__1();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Person__Group__0


    // $ANTLR start rule__Person__Group__0__Impl
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:608:1: rule__Person__Group__0__Impl : ( 'Person' ) ;
    public final void rule__Person__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:612:1: ( ( 'Person' ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:613:1: ( 'Person' )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:613:1: ( 'Person' )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:614:1: 'Person'
            {
             before(grammarAccess.getPersonAccess().getPersonKeyword_0()); 
            match(input,19,FOLLOW_19_in_rule__Person__Group__0__Impl1196); 
             after(grammarAccess.getPersonAccess().getPersonKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Person__Group__0__Impl


    // $ANTLR start rule__Person__Group__1
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:627:1: rule__Person__Group__1 : rule__Person__Group__1__Impl rule__Person__Group__2 ;
    public final void rule__Person__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:631:1: ( rule__Person__Group__1__Impl rule__Person__Group__2 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:632:2: rule__Person__Group__1__Impl rule__Person__Group__2
            {
            pushFollow(FOLLOW_rule__Person__Group__1__Impl_in_rule__Person__Group__11227);
            rule__Person__Group__1__Impl();
            _fsp--;

            pushFollow(FOLLOW_rule__Person__Group__2_in_rule__Person__Group__11230);
            rule__Person__Group__2();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Person__Group__1


    // $ANTLR start rule__Person__Group__1__Impl
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:639:1: rule__Person__Group__1__Impl : ( ( rule__Person__NameAssignment_1 ) ) ;
    public final void rule__Person__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:643:1: ( ( ( rule__Person__NameAssignment_1 ) ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:644:1: ( ( rule__Person__NameAssignment_1 ) )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:644:1: ( ( rule__Person__NameAssignment_1 ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:645:1: ( rule__Person__NameAssignment_1 )
            {
             before(grammarAccess.getPersonAccess().getNameAssignment_1()); 
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:646:1: ( rule__Person__NameAssignment_1 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:646:2: rule__Person__NameAssignment_1
            {
            pushFollow(FOLLOW_rule__Person__NameAssignment_1_in_rule__Person__Group__1__Impl1257);
            rule__Person__NameAssignment_1();
            _fsp--;


            }

             after(grammarAccess.getPersonAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Person__Group__1__Impl


    // $ANTLR start rule__Person__Group__2
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:656:1: rule__Person__Group__2 : rule__Person__Group__2__Impl rule__Person__Group__3 ;
    public final void rule__Person__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:660:1: ( rule__Person__Group__2__Impl rule__Person__Group__3 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:661:2: rule__Person__Group__2__Impl rule__Person__Group__3
            {
            pushFollow(FOLLOW_rule__Person__Group__2__Impl_in_rule__Person__Group__21287);
            rule__Person__Group__2__Impl();
            _fsp--;

            pushFollow(FOLLOW_rule__Person__Group__3_in_rule__Person__Group__21290);
            rule__Person__Group__3();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Person__Group__2


    // $ANTLR start rule__Person__Group__2__Impl
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:668:1: rule__Person__Group__2__Impl : ( '{' ) ;
    public final void rule__Person__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:672:1: ( ( '{' ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:673:1: ( '{' )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:673:1: ( '{' )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:674:1: '{'
            {
             before(grammarAccess.getPersonAccess().getLeftCurlyBracketKeyword_2()); 
            match(input,16,FOLLOW_16_in_rule__Person__Group__2__Impl1318); 
             after(grammarAccess.getPersonAccess().getLeftCurlyBracketKeyword_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Person__Group__2__Impl


    // $ANTLR start rule__Person__Group__3
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:687:1: rule__Person__Group__3 : rule__Person__Group__3__Impl rule__Person__Group__4 ;
    public final void rule__Person__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:691:1: ( rule__Person__Group__3__Impl rule__Person__Group__4 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:692:2: rule__Person__Group__3__Impl rule__Person__Group__4
            {
            pushFollow(FOLLOW_rule__Person__Group__3__Impl_in_rule__Person__Group__31349);
            rule__Person__Group__3__Impl();
            _fsp--;

            pushFollow(FOLLOW_rule__Person__Group__4_in_rule__Person__Group__31352);
            rule__Person__Group__4();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Person__Group__3


    // $ANTLR start rule__Person__Group__3__Impl
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:699:1: rule__Person__Group__3__Impl : ( ( rule__Person__SexAssignment_3 ) ) ;
    public final void rule__Person__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:703:1: ( ( ( rule__Person__SexAssignment_3 ) ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:704:1: ( ( rule__Person__SexAssignment_3 ) )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:704:1: ( ( rule__Person__SexAssignment_3 ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:705:1: ( rule__Person__SexAssignment_3 )
            {
             before(grammarAccess.getPersonAccess().getSexAssignment_3()); 
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:706:1: ( rule__Person__SexAssignment_3 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:706:2: rule__Person__SexAssignment_3
            {
            pushFollow(FOLLOW_rule__Person__SexAssignment_3_in_rule__Person__Group__3__Impl1379);
            rule__Person__SexAssignment_3();
            _fsp--;


            }

             after(grammarAccess.getPersonAccess().getSexAssignment_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Person__Group__3__Impl


    // $ANTLR start rule__Person__Group__4
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:716:1: rule__Person__Group__4 : rule__Person__Group__4__Impl rule__Person__Group__5 ;
    public final void rule__Person__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:720:1: ( rule__Person__Group__4__Impl rule__Person__Group__5 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:721:2: rule__Person__Group__4__Impl rule__Person__Group__5
            {
            pushFollow(FOLLOW_rule__Person__Group__4__Impl_in_rule__Person__Group__41409);
            rule__Person__Group__4__Impl();
            _fsp--;

            pushFollow(FOLLOW_rule__Person__Group__5_in_rule__Person__Group__41412);
            rule__Person__Group__5();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Person__Group__4


    // $ANTLR start rule__Person__Group__4__Impl
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:728:1: rule__Person__Group__4__Impl : ( ( rule__Person__Group_4__0 )? ) ;
    public final void rule__Person__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:732:1: ( ( ( rule__Person__Group_4__0 )? ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:733:1: ( ( rule__Person__Group_4__0 )? )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:733:1: ( ( rule__Person__Group_4__0 )? )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:734:1: ( rule__Person__Group_4__0 )?
            {
             before(grammarAccess.getPersonAccess().getGroup_4()); 
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:735:1: ( rule__Person__Group_4__0 )?
            int alt6=2;
            int LA6_0 = input.LA(1);

            if ( (LA6_0==20) ) {
                alt6=1;
            }
            switch (alt6) {
                case 1 :
                    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:735:2: rule__Person__Group_4__0
                    {
                    pushFollow(FOLLOW_rule__Person__Group_4__0_in_rule__Person__Group__4__Impl1439);
                    rule__Person__Group_4__0();
                    _fsp--;


                    }
                    break;

            }

             after(grammarAccess.getPersonAccess().getGroup_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Person__Group__4__Impl


    // $ANTLR start rule__Person__Group__5
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:745:1: rule__Person__Group__5 : rule__Person__Group__5__Impl ;
    public final void rule__Person__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:749:1: ( rule__Person__Group__5__Impl )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:750:2: rule__Person__Group__5__Impl
            {
            pushFollow(FOLLOW_rule__Person__Group__5__Impl_in_rule__Person__Group__51470);
            rule__Person__Group__5__Impl();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Person__Group__5


    // $ANTLR start rule__Person__Group__5__Impl
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:756:1: rule__Person__Group__5__Impl : ( '}' ) ;
    public final void rule__Person__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:760:1: ( ( '}' ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:761:1: ( '}' )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:761:1: ( '}' )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:762:1: '}'
            {
             before(grammarAccess.getPersonAccess().getRightCurlyBracketKeyword_5()); 
            match(input,17,FOLLOW_17_in_rule__Person__Group__5__Impl1498); 
             after(grammarAccess.getPersonAccess().getRightCurlyBracketKeyword_5()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Person__Group__5__Impl


    // $ANTLR start rule__Person__Group_4__0
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:787:1: rule__Person__Group_4__0 : rule__Person__Group_4__0__Impl rule__Person__Group_4__1 ;
    public final void rule__Person__Group_4__0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:791:1: ( rule__Person__Group_4__0__Impl rule__Person__Group_4__1 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:792:2: rule__Person__Group_4__0__Impl rule__Person__Group_4__1
            {
            pushFollow(FOLLOW_rule__Person__Group_4__0__Impl_in_rule__Person__Group_4__01541);
            rule__Person__Group_4__0__Impl();
            _fsp--;

            pushFollow(FOLLOW_rule__Person__Group_4__1_in_rule__Person__Group_4__01544);
            rule__Person__Group_4__1();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Person__Group_4__0


    // $ANTLR start rule__Person__Group_4__0__Impl
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:799:1: rule__Person__Group_4__0__Impl : ( 'memberships' ) ;
    public final void rule__Person__Group_4__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:803:1: ( ( 'memberships' ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:804:1: ( 'memberships' )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:804:1: ( 'memberships' )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:805:1: 'memberships'
            {
             before(grammarAccess.getPersonAccess().getMembershipsKeyword_4_0()); 
            match(input,20,FOLLOW_20_in_rule__Person__Group_4__0__Impl1572); 
             after(grammarAccess.getPersonAccess().getMembershipsKeyword_4_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Person__Group_4__0__Impl


    // $ANTLR start rule__Person__Group_4__1
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:818:1: rule__Person__Group_4__1 : rule__Person__Group_4__1__Impl rule__Person__Group_4__2 ;
    public final void rule__Person__Group_4__1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:822:1: ( rule__Person__Group_4__1__Impl rule__Person__Group_4__2 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:823:2: rule__Person__Group_4__1__Impl rule__Person__Group_4__2
            {
            pushFollow(FOLLOW_rule__Person__Group_4__1__Impl_in_rule__Person__Group_4__11603);
            rule__Person__Group_4__1__Impl();
            _fsp--;

            pushFollow(FOLLOW_rule__Person__Group_4__2_in_rule__Person__Group_4__11606);
            rule__Person__Group_4__2();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Person__Group_4__1


    // $ANTLR start rule__Person__Group_4__1__Impl
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:830:1: rule__Person__Group_4__1__Impl : ( ( rule__Person__MembershipAssignment_4_1 ) ) ;
    public final void rule__Person__Group_4__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:834:1: ( ( ( rule__Person__MembershipAssignment_4_1 ) ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:835:1: ( ( rule__Person__MembershipAssignment_4_1 ) )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:835:1: ( ( rule__Person__MembershipAssignment_4_1 ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:836:1: ( rule__Person__MembershipAssignment_4_1 )
            {
             before(grammarAccess.getPersonAccess().getMembershipAssignment_4_1()); 
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:837:1: ( rule__Person__MembershipAssignment_4_1 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:837:2: rule__Person__MembershipAssignment_4_1
            {
            pushFollow(FOLLOW_rule__Person__MembershipAssignment_4_1_in_rule__Person__Group_4__1__Impl1633);
            rule__Person__MembershipAssignment_4_1();
            _fsp--;


            }

             after(grammarAccess.getPersonAccess().getMembershipAssignment_4_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Person__Group_4__1__Impl


    // $ANTLR start rule__Person__Group_4__2
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:847:1: rule__Person__Group_4__2 : rule__Person__Group_4__2__Impl ;
    public final void rule__Person__Group_4__2() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:851:1: ( rule__Person__Group_4__2__Impl )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:852:2: rule__Person__Group_4__2__Impl
            {
            pushFollow(FOLLOW_rule__Person__Group_4__2__Impl_in_rule__Person__Group_4__21663);
            rule__Person__Group_4__2__Impl();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Person__Group_4__2


    // $ANTLR start rule__Person__Group_4__2__Impl
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:858:1: rule__Person__Group_4__2__Impl : ( ( rule__Person__Group_4_2__0 )* ) ;
    public final void rule__Person__Group_4__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:862:1: ( ( ( rule__Person__Group_4_2__0 )* ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:863:1: ( ( rule__Person__Group_4_2__0 )* )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:863:1: ( ( rule__Person__Group_4_2__0 )* )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:864:1: ( rule__Person__Group_4_2__0 )*
            {
             before(grammarAccess.getPersonAccess().getGroup_4_2()); 
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:865:1: ( rule__Person__Group_4_2__0 )*
            loop7:
            do {
                int alt7=2;
                int LA7_0 = input.LA(1);

                if ( (LA7_0==21) ) {
                    alt7=1;
                }


                switch (alt7) {
            	case 1 :
            	    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:865:2: rule__Person__Group_4_2__0
            	    {
            	    pushFollow(FOLLOW_rule__Person__Group_4_2__0_in_rule__Person__Group_4__2__Impl1690);
            	    rule__Person__Group_4_2__0();
            	    _fsp--;


            	    }
            	    break;

            	default :
            	    break loop7;
                }
            } while (true);

             after(grammarAccess.getPersonAccess().getGroup_4_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Person__Group_4__2__Impl


    // $ANTLR start rule__Person__Group_4_2__0
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:881:1: rule__Person__Group_4_2__0 : rule__Person__Group_4_2__0__Impl rule__Person__Group_4_2__1 ;
    public final void rule__Person__Group_4_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:885:1: ( rule__Person__Group_4_2__0__Impl rule__Person__Group_4_2__1 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:886:2: rule__Person__Group_4_2__0__Impl rule__Person__Group_4_2__1
            {
            pushFollow(FOLLOW_rule__Person__Group_4_2__0__Impl_in_rule__Person__Group_4_2__01727);
            rule__Person__Group_4_2__0__Impl();
            _fsp--;

            pushFollow(FOLLOW_rule__Person__Group_4_2__1_in_rule__Person__Group_4_2__01730);
            rule__Person__Group_4_2__1();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Person__Group_4_2__0


    // $ANTLR start rule__Person__Group_4_2__0__Impl
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:893:1: rule__Person__Group_4_2__0__Impl : ( ',' ) ;
    public final void rule__Person__Group_4_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:897:1: ( ( ',' ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:898:1: ( ',' )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:898:1: ( ',' )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:899:1: ','
            {
             before(grammarAccess.getPersonAccess().getCommaKeyword_4_2_0()); 
            match(input,21,FOLLOW_21_in_rule__Person__Group_4_2__0__Impl1758); 
             after(grammarAccess.getPersonAccess().getCommaKeyword_4_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Person__Group_4_2__0__Impl


    // $ANTLR start rule__Person__Group_4_2__1
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:912:1: rule__Person__Group_4_2__1 : rule__Person__Group_4_2__1__Impl ;
    public final void rule__Person__Group_4_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:916:1: ( rule__Person__Group_4_2__1__Impl )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:917:2: rule__Person__Group_4_2__1__Impl
            {
            pushFollow(FOLLOW_rule__Person__Group_4_2__1__Impl_in_rule__Person__Group_4_2__11789);
            rule__Person__Group_4_2__1__Impl();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Person__Group_4_2__1


    // $ANTLR start rule__Person__Group_4_2__1__Impl
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:923:1: rule__Person__Group_4_2__1__Impl : ( ( rule__Person__MembershipAssignment_4_2_1 ) ) ;
    public final void rule__Person__Group_4_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:927:1: ( ( ( rule__Person__MembershipAssignment_4_2_1 ) ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:928:1: ( ( rule__Person__MembershipAssignment_4_2_1 ) )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:928:1: ( ( rule__Person__MembershipAssignment_4_2_1 ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:929:1: ( rule__Person__MembershipAssignment_4_2_1 )
            {
             before(grammarAccess.getPersonAccess().getMembershipAssignment_4_2_1()); 
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:930:1: ( rule__Person__MembershipAssignment_4_2_1 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:930:2: rule__Person__MembershipAssignment_4_2_1
            {
            pushFollow(FOLLOW_rule__Person__MembershipAssignment_4_2_1_in_rule__Person__Group_4_2__1__Impl1816);
            rule__Person__MembershipAssignment_4_2_1();
            _fsp--;


            }

             after(grammarAccess.getPersonAccess().getMembershipAssignment_4_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Person__Group_4_2__1__Impl


    // $ANTLR start rule__Community__Group__0
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:944:1: rule__Community__Group__0 : rule__Community__Group__0__Impl rule__Community__Group__1 ;
    public final void rule__Community__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:948:1: ( rule__Community__Group__0__Impl rule__Community__Group__1 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:949:2: rule__Community__Group__0__Impl rule__Community__Group__1
            {
            pushFollow(FOLLOW_rule__Community__Group__0__Impl_in_rule__Community__Group__01850);
            rule__Community__Group__0__Impl();
            _fsp--;

            pushFollow(FOLLOW_rule__Community__Group__1_in_rule__Community__Group__01853);
            rule__Community__Group__1();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Community__Group__0


    // $ANTLR start rule__Community__Group__0__Impl
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:956:1: rule__Community__Group__0__Impl : ( 'Community' ) ;
    public final void rule__Community__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:960:1: ( ( 'Community' ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:961:1: ( 'Community' )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:961:1: ( 'Community' )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:962:1: 'Community'
            {
             before(grammarAccess.getCommunityAccess().getCommunityKeyword_0()); 
            match(input,22,FOLLOW_22_in_rule__Community__Group__0__Impl1881); 
             after(grammarAccess.getCommunityAccess().getCommunityKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Community__Group__0__Impl


    // $ANTLR start rule__Community__Group__1
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:975:1: rule__Community__Group__1 : rule__Community__Group__1__Impl rule__Community__Group__2 ;
    public final void rule__Community__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:979:1: ( rule__Community__Group__1__Impl rule__Community__Group__2 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:980:2: rule__Community__Group__1__Impl rule__Community__Group__2
            {
            pushFollow(FOLLOW_rule__Community__Group__1__Impl_in_rule__Community__Group__11912);
            rule__Community__Group__1__Impl();
            _fsp--;

            pushFollow(FOLLOW_rule__Community__Group__2_in_rule__Community__Group__11915);
            rule__Community__Group__2();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Community__Group__1


    // $ANTLR start rule__Community__Group__1__Impl
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:987:1: rule__Community__Group__1__Impl : ( ( rule__Community__NameAssignment_1 ) ) ;
    public final void rule__Community__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:991:1: ( ( ( rule__Community__NameAssignment_1 ) ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:992:1: ( ( rule__Community__NameAssignment_1 ) )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:992:1: ( ( rule__Community__NameAssignment_1 ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:993:1: ( rule__Community__NameAssignment_1 )
            {
             before(grammarAccess.getCommunityAccess().getNameAssignment_1()); 
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:994:1: ( rule__Community__NameAssignment_1 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:994:2: rule__Community__NameAssignment_1
            {
            pushFollow(FOLLOW_rule__Community__NameAssignment_1_in_rule__Community__Group__1__Impl1942);
            rule__Community__NameAssignment_1();
            _fsp--;


            }

             after(grammarAccess.getCommunityAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Community__Group__1__Impl


    // $ANTLR start rule__Community__Group__2
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1004:1: rule__Community__Group__2 : rule__Community__Group__2__Impl ;
    public final void rule__Community__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1008:1: ( rule__Community__Group__2__Impl )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1009:2: rule__Community__Group__2__Impl
            {
            pushFollow(FOLLOW_rule__Community__Group__2__Impl_in_rule__Community__Group__21972);
            rule__Community__Group__2__Impl();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Community__Group__2


    // $ANTLR start rule__Community__Group__2__Impl
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1015:1: rule__Community__Group__2__Impl : ( ( rule__Community__Group_2__0 )? ) ;
    public final void rule__Community__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1019:1: ( ( ( rule__Community__Group_2__0 )? ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1020:1: ( ( rule__Community__Group_2__0 )? )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1020:1: ( ( rule__Community__Group_2__0 )? )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1021:1: ( rule__Community__Group_2__0 )?
            {
             before(grammarAccess.getCommunityAccess().getGroup_2()); 
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1022:1: ( rule__Community__Group_2__0 )?
            int alt8=2;
            int LA8_0 = input.LA(1);

            if ( (LA8_0==16) ) {
                alt8=1;
            }
            switch (alt8) {
                case 1 :
                    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1022:2: rule__Community__Group_2__0
                    {
                    pushFollow(FOLLOW_rule__Community__Group_2__0_in_rule__Community__Group__2__Impl1999);
                    rule__Community__Group_2__0();
                    _fsp--;


                    }
                    break;

            }

             after(grammarAccess.getCommunityAccess().getGroup_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Community__Group__2__Impl


    // $ANTLR start rule__Community__Group_2__0
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1038:1: rule__Community__Group_2__0 : rule__Community__Group_2__0__Impl rule__Community__Group_2__1 ;
    public final void rule__Community__Group_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1042:1: ( rule__Community__Group_2__0__Impl rule__Community__Group_2__1 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1043:2: rule__Community__Group_2__0__Impl rule__Community__Group_2__1
            {
            pushFollow(FOLLOW_rule__Community__Group_2__0__Impl_in_rule__Community__Group_2__02036);
            rule__Community__Group_2__0__Impl();
            _fsp--;

            pushFollow(FOLLOW_rule__Community__Group_2__1_in_rule__Community__Group_2__02039);
            rule__Community__Group_2__1();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Community__Group_2__0


    // $ANTLR start rule__Community__Group_2__0__Impl
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1050:1: rule__Community__Group_2__0__Impl : ( '{' ) ;
    public final void rule__Community__Group_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1054:1: ( ( '{' ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1055:1: ( '{' )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1055:1: ( '{' )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1056:1: '{'
            {
             before(grammarAccess.getCommunityAccess().getLeftCurlyBracketKeyword_2_0()); 
            match(input,16,FOLLOW_16_in_rule__Community__Group_2__0__Impl2067); 
             after(grammarAccess.getCommunityAccess().getLeftCurlyBracketKeyword_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Community__Group_2__0__Impl


    // $ANTLR start rule__Community__Group_2__1
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1069:1: rule__Community__Group_2__1 : rule__Community__Group_2__1__Impl rule__Community__Group_2__2 ;
    public final void rule__Community__Group_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1073:1: ( rule__Community__Group_2__1__Impl rule__Community__Group_2__2 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1074:2: rule__Community__Group_2__1__Impl rule__Community__Group_2__2
            {
            pushFollow(FOLLOW_rule__Community__Group_2__1__Impl_in_rule__Community__Group_2__12098);
            rule__Community__Group_2__1__Impl();
            _fsp--;

            pushFollow(FOLLOW_rule__Community__Group_2__2_in_rule__Community__Group_2__12101);
            rule__Community__Group_2__2();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Community__Group_2__1


    // $ANTLR start rule__Community__Group_2__1__Impl
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1081:1: rule__Community__Group_2__1__Impl : ( ( rule__Community__ChildrenAssignment_2_1 ) ) ;
    public final void rule__Community__Group_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1085:1: ( ( ( rule__Community__ChildrenAssignment_2_1 ) ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1086:1: ( ( rule__Community__ChildrenAssignment_2_1 ) )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1086:1: ( ( rule__Community__ChildrenAssignment_2_1 ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1087:1: ( rule__Community__ChildrenAssignment_2_1 )
            {
             before(grammarAccess.getCommunityAccess().getChildrenAssignment_2_1()); 
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1088:1: ( rule__Community__ChildrenAssignment_2_1 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1088:2: rule__Community__ChildrenAssignment_2_1
            {
            pushFollow(FOLLOW_rule__Community__ChildrenAssignment_2_1_in_rule__Community__Group_2__1__Impl2128);
            rule__Community__ChildrenAssignment_2_1();
            _fsp--;


            }

             after(grammarAccess.getCommunityAccess().getChildrenAssignment_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Community__Group_2__1__Impl


    // $ANTLR start rule__Community__Group_2__2
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1098:1: rule__Community__Group_2__2 : rule__Community__Group_2__2__Impl rule__Community__Group_2__3 ;
    public final void rule__Community__Group_2__2() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1102:1: ( rule__Community__Group_2__2__Impl rule__Community__Group_2__3 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1103:2: rule__Community__Group_2__2__Impl rule__Community__Group_2__3
            {
            pushFollow(FOLLOW_rule__Community__Group_2__2__Impl_in_rule__Community__Group_2__22158);
            rule__Community__Group_2__2__Impl();
            _fsp--;

            pushFollow(FOLLOW_rule__Community__Group_2__3_in_rule__Community__Group_2__22161);
            rule__Community__Group_2__3();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Community__Group_2__2


    // $ANTLR start rule__Community__Group_2__2__Impl
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1110:1: rule__Community__Group_2__2__Impl : ( ( rule__Community__Group_2_2__0 )* ) ;
    public final void rule__Community__Group_2__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1114:1: ( ( ( rule__Community__Group_2_2__0 )* ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1115:1: ( ( rule__Community__Group_2_2__0 )* )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1115:1: ( ( rule__Community__Group_2_2__0 )* )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1116:1: ( rule__Community__Group_2_2__0 )*
            {
             before(grammarAccess.getCommunityAccess().getGroup_2_2()); 
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1117:1: ( rule__Community__Group_2_2__0 )*
            loop9:
            do {
                int alt9=2;
                int LA9_0 = input.LA(1);

                if ( (LA9_0==21) ) {
                    alt9=1;
                }


                switch (alt9) {
            	case 1 :
            	    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1117:2: rule__Community__Group_2_2__0
            	    {
            	    pushFollow(FOLLOW_rule__Community__Group_2_2__0_in_rule__Community__Group_2__2__Impl2188);
            	    rule__Community__Group_2_2__0();
            	    _fsp--;


            	    }
            	    break;

            	default :
            	    break loop9;
                }
            } while (true);

             after(grammarAccess.getCommunityAccess().getGroup_2_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Community__Group_2__2__Impl


    // $ANTLR start rule__Community__Group_2__3
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1127:1: rule__Community__Group_2__3 : rule__Community__Group_2__3__Impl ;
    public final void rule__Community__Group_2__3() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1131:1: ( rule__Community__Group_2__3__Impl )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1132:2: rule__Community__Group_2__3__Impl
            {
            pushFollow(FOLLOW_rule__Community__Group_2__3__Impl_in_rule__Community__Group_2__32219);
            rule__Community__Group_2__3__Impl();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Community__Group_2__3


    // $ANTLR start rule__Community__Group_2__3__Impl
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1138:1: rule__Community__Group_2__3__Impl : ( '}' ) ;
    public final void rule__Community__Group_2__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1142:1: ( ( '}' ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1143:1: ( '}' )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1143:1: ( '}' )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1144:1: '}'
            {
             before(grammarAccess.getCommunityAccess().getRightCurlyBracketKeyword_2_3()); 
            match(input,17,FOLLOW_17_in_rule__Community__Group_2__3__Impl2247); 
             after(grammarAccess.getCommunityAccess().getRightCurlyBracketKeyword_2_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Community__Group_2__3__Impl


    // $ANTLR start rule__Community__Group_2_2__0
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1165:1: rule__Community__Group_2_2__0 : rule__Community__Group_2_2__0__Impl rule__Community__Group_2_2__1 ;
    public final void rule__Community__Group_2_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1169:1: ( rule__Community__Group_2_2__0__Impl rule__Community__Group_2_2__1 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1170:2: rule__Community__Group_2_2__0__Impl rule__Community__Group_2_2__1
            {
            pushFollow(FOLLOW_rule__Community__Group_2_2__0__Impl_in_rule__Community__Group_2_2__02286);
            rule__Community__Group_2_2__0__Impl();
            _fsp--;

            pushFollow(FOLLOW_rule__Community__Group_2_2__1_in_rule__Community__Group_2_2__02289);
            rule__Community__Group_2_2__1();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Community__Group_2_2__0


    // $ANTLR start rule__Community__Group_2_2__0__Impl
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1177:1: rule__Community__Group_2_2__0__Impl : ( ',' ) ;
    public final void rule__Community__Group_2_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1181:1: ( ( ',' ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1182:1: ( ',' )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1182:1: ( ',' )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1183:1: ','
            {
             before(grammarAccess.getCommunityAccess().getCommaKeyword_2_2_0()); 
            match(input,21,FOLLOW_21_in_rule__Community__Group_2_2__0__Impl2317); 
             after(grammarAccess.getCommunityAccess().getCommaKeyword_2_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Community__Group_2_2__0__Impl


    // $ANTLR start rule__Community__Group_2_2__1
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1196:1: rule__Community__Group_2_2__1 : rule__Community__Group_2_2__1__Impl ;
    public final void rule__Community__Group_2_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1200:1: ( rule__Community__Group_2_2__1__Impl )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1201:2: rule__Community__Group_2_2__1__Impl
            {
            pushFollow(FOLLOW_rule__Community__Group_2_2__1__Impl_in_rule__Community__Group_2_2__12348);
            rule__Community__Group_2_2__1__Impl();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Community__Group_2_2__1


    // $ANTLR start rule__Community__Group_2_2__1__Impl
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1207:1: rule__Community__Group_2_2__1__Impl : ( ( rule__Community__ChildrenAssignment_2_2_1 ) ) ;
    public final void rule__Community__Group_2_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1211:1: ( ( ( rule__Community__ChildrenAssignment_2_2_1 ) ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1212:1: ( ( rule__Community__ChildrenAssignment_2_2_1 ) )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1212:1: ( ( rule__Community__ChildrenAssignment_2_2_1 ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1213:1: ( rule__Community__ChildrenAssignment_2_2_1 )
            {
             before(grammarAccess.getCommunityAccess().getChildrenAssignment_2_2_1()); 
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1214:1: ( rule__Community__ChildrenAssignment_2_2_1 )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1214:2: rule__Community__ChildrenAssignment_2_2_1
            {
            pushFollow(FOLLOW_rule__Community__ChildrenAssignment_2_2_1_in_rule__Community__Group_2_2__1__Impl2375);
            rule__Community__ChildrenAssignment_2_2_1();
            _fsp--;


            }

             after(grammarAccess.getCommunityAccess().getChildrenAssignment_2_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Community__Group_2_2__1__Impl


    // $ANTLR start rule__SocialNetwork__EntitiesAssignment_2
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1229:1: rule__SocialNetwork__EntitiesAssignment_2 : ( ruleSocialEntity ) ;
    public final void rule__SocialNetwork__EntitiesAssignment_2() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1233:1: ( ( ruleSocialEntity ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1234:1: ( ruleSocialEntity )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1234:1: ( ruleSocialEntity )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1235:1: ruleSocialEntity
            {
             before(grammarAccess.getSocialNetworkAccess().getEntitiesSocialEntityParserRuleCall_2_0()); 
            pushFollow(FOLLOW_ruleSocialEntity_in_rule__SocialNetwork__EntitiesAssignment_22414);
            ruleSocialEntity();
            _fsp--;

             after(grammarAccess.getSocialNetworkAccess().getEntitiesSocialEntityParserRuleCall_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__SocialNetwork__EntitiesAssignment_2


    // $ANTLR start rule__SocialNetwork__AquaintancesAssignment_3
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1244:1: rule__SocialNetwork__AquaintancesAssignment_3 : ( ruleAquaintance ) ;
    public final void rule__SocialNetwork__AquaintancesAssignment_3() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1248:1: ( ( ruleAquaintance ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1249:1: ( ruleAquaintance )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1249:1: ( ruleAquaintance )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1250:1: ruleAquaintance
            {
             before(grammarAccess.getSocialNetworkAccess().getAquaintancesAquaintanceParserRuleCall_3_0()); 
            pushFollow(FOLLOW_ruleAquaintance_in_rule__SocialNetwork__AquaintancesAssignment_32445);
            ruleAquaintance();
            _fsp--;

             after(grammarAccess.getSocialNetworkAccess().getAquaintancesAquaintanceParserRuleCall_3_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__SocialNetwork__AquaintancesAssignment_3


    // $ANTLR start rule__Aquaintance__SourceAssignment_0
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1259:1: rule__Aquaintance__SourceAssignment_0 : ( ( RULE_ID ) ) ;
    public final void rule__Aquaintance__SourceAssignment_0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1263:1: ( ( ( RULE_ID ) ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1264:1: ( ( RULE_ID ) )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1264:1: ( ( RULE_ID ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1265:1: ( RULE_ID )
            {
             before(grammarAccess.getAquaintanceAccess().getSourcePersonCrossReference_0_0()); 
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1266:1: ( RULE_ID )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1267:1: RULE_ID
            {
             before(grammarAccess.getAquaintanceAccess().getSourcePersonIDTerminalRuleCall_0_0_1()); 
            match(input,RULE_ID,FOLLOW_RULE_ID_in_rule__Aquaintance__SourceAssignment_02480); 
             after(grammarAccess.getAquaintanceAccess().getSourcePersonIDTerminalRuleCall_0_0_1()); 

            }

             after(grammarAccess.getAquaintanceAccess().getSourcePersonCrossReference_0_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Aquaintance__SourceAssignment_0


    // $ANTLR start rule__Aquaintance__TypeAssignment_2
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1278:1: rule__Aquaintance__TypeAssignment_2 : ( ruleAquaintanceType ) ;
    public final void rule__Aquaintance__TypeAssignment_2() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1282:1: ( ( ruleAquaintanceType ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1283:1: ( ruleAquaintanceType )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1283:1: ( ruleAquaintanceType )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1284:1: ruleAquaintanceType
            {
             before(grammarAccess.getAquaintanceAccess().getTypeAquaintanceTypeEnumRuleCall_2_0()); 
            pushFollow(FOLLOW_ruleAquaintanceType_in_rule__Aquaintance__TypeAssignment_22515);
            ruleAquaintanceType();
            _fsp--;

             after(grammarAccess.getAquaintanceAccess().getTypeAquaintanceTypeEnumRuleCall_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Aquaintance__TypeAssignment_2


    // $ANTLR start rule__Aquaintance__TargetAssignment_3
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1293:1: rule__Aquaintance__TargetAssignment_3 : ( ( RULE_ID ) ) ;
    public final void rule__Aquaintance__TargetAssignment_3() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1297:1: ( ( ( RULE_ID ) ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1298:1: ( ( RULE_ID ) )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1298:1: ( ( RULE_ID ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1299:1: ( RULE_ID )
            {
             before(grammarAccess.getAquaintanceAccess().getTargetPersonCrossReference_3_0()); 
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1300:1: ( RULE_ID )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1301:1: RULE_ID
            {
             before(grammarAccess.getAquaintanceAccess().getTargetPersonIDTerminalRuleCall_3_0_1()); 
            match(input,RULE_ID,FOLLOW_RULE_ID_in_rule__Aquaintance__TargetAssignment_32550); 
             after(grammarAccess.getAquaintanceAccess().getTargetPersonIDTerminalRuleCall_3_0_1()); 

            }

             after(grammarAccess.getAquaintanceAccess().getTargetPersonCrossReference_3_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Aquaintance__TargetAssignment_3


    // $ANTLR start rule__Person__NameAssignment_1
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1312:1: rule__Person__NameAssignment_1 : ( RULE_ID ) ;
    public final void rule__Person__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1316:1: ( ( RULE_ID ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1317:1: ( RULE_ID )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1317:1: ( RULE_ID )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1318:1: RULE_ID
            {
             before(grammarAccess.getPersonAccess().getNameIDTerminalRuleCall_1_0()); 
            match(input,RULE_ID,FOLLOW_RULE_ID_in_rule__Person__NameAssignment_12585); 
             after(grammarAccess.getPersonAccess().getNameIDTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Person__NameAssignment_1


    // $ANTLR start rule__Person__SexAssignment_3
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1327:1: rule__Person__SexAssignment_3 : ( ruleSex ) ;
    public final void rule__Person__SexAssignment_3() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1331:1: ( ( ruleSex ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1332:1: ( ruleSex )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1332:1: ( ruleSex )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1333:1: ruleSex
            {
             before(grammarAccess.getPersonAccess().getSexSexEnumRuleCall_3_0()); 
            pushFollow(FOLLOW_ruleSex_in_rule__Person__SexAssignment_32616);
            ruleSex();
            _fsp--;

             after(grammarAccess.getPersonAccess().getSexSexEnumRuleCall_3_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Person__SexAssignment_3


    // $ANTLR start rule__Person__MembershipAssignment_4_1
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1342:1: rule__Person__MembershipAssignment_4_1 : ( ( RULE_ID ) ) ;
    public final void rule__Person__MembershipAssignment_4_1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1346:1: ( ( ( RULE_ID ) ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1347:1: ( ( RULE_ID ) )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1347:1: ( ( RULE_ID ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1348:1: ( RULE_ID )
            {
             before(grammarAccess.getPersonAccess().getMembershipCommunityCrossReference_4_1_0()); 
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1349:1: ( RULE_ID )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1350:1: RULE_ID
            {
             before(grammarAccess.getPersonAccess().getMembershipCommunityIDTerminalRuleCall_4_1_0_1()); 
            match(input,RULE_ID,FOLLOW_RULE_ID_in_rule__Person__MembershipAssignment_4_12651); 
             after(grammarAccess.getPersonAccess().getMembershipCommunityIDTerminalRuleCall_4_1_0_1()); 

            }

             after(grammarAccess.getPersonAccess().getMembershipCommunityCrossReference_4_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Person__MembershipAssignment_4_1


    // $ANTLR start rule__Person__MembershipAssignment_4_2_1
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1361:1: rule__Person__MembershipAssignment_4_2_1 : ( ( RULE_ID ) ) ;
    public final void rule__Person__MembershipAssignment_4_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1365:1: ( ( ( RULE_ID ) ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1366:1: ( ( RULE_ID ) )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1366:1: ( ( RULE_ID ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1367:1: ( RULE_ID )
            {
             before(grammarAccess.getPersonAccess().getMembershipCommunityCrossReference_4_2_1_0()); 
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1368:1: ( RULE_ID )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1369:1: RULE_ID
            {
             before(grammarAccess.getPersonAccess().getMembershipCommunityIDTerminalRuleCall_4_2_1_0_1()); 
            match(input,RULE_ID,FOLLOW_RULE_ID_in_rule__Person__MembershipAssignment_4_2_12690); 
             after(grammarAccess.getPersonAccess().getMembershipCommunityIDTerminalRuleCall_4_2_1_0_1()); 

            }

             after(grammarAccess.getPersonAccess().getMembershipCommunityCrossReference_4_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Person__MembershipAssignment_4_2_1


    // $ANTLR start rule__Community__NameAssignment_1
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1380:1: rule__Community__NameAssignment_1 : ( RULE_ID ) ;
    public final void rule__Community__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1384:1: ( ( RULE_ID ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1385:1: ( RULE_ID )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1385:1: ( RULE_ID )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1386:1: RULE_ID
            {
             before(grammarAccess.getCommunityAccess().getNameIDTerminalRuleCall_1_0()); 
            match(input,RULE_ID,FOLLOW_RULE_ID_in_rule__Community__NameAssignment_12725); 
             after(grammarAccess.getCommunityAccess().getNameIDTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Community__NameAssignment_1


    // $ANTLR start rule__Community__ChildrenAssignment_2_1
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1395:1: rule__Community__ChildrenAssignment_2_1 : ( ruleCommunity ) ;
    public final void rule__Community__ChildrenAssignment_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1399:1: ( ( ruleCommunity ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1400:1: ( ruleCommunity )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1400:1: ( ruleCommunity )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1401:1: ruleCommunity
            {
             before(grammarAccess.getCommunityAccess().getChildrenCommunityParserRuleCall_2_1_0()); 
            pushFollow(FOLLOW_ruleCommunity_in_rule__Community__ChildrenAssignment_2_12756);
            ruleCommunity();
            _fsp--;

             after(grammarAccess.getCommunityAccess().getChildrenCommunityParserRuleCall_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Community__ChildrenAssignment_2_1


    // $ANTLR start rule__Community__ChildrenAssignment_2_2_1
    // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1410:1: rule__Community__ChildrenAssignment_2_2_1 : ( ruleCommunity ) ;
    public final void rule__Community__ChildrenAssignment_2_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1414:1: ( ( ruleCommunity ) )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1415:1: ( ruleCommunity )
            {
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1415:1: ( ruleCommunity )
            // ../hu.bme.mit.socialnetwork.text.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialnetwork.g:1416:1: ruleCommunity
            {
             before(grammarAccess.getCommunityAccess().getChildrenCommunityParserRuleCall_2_2_1_0()); 
            pushFollow(FOLLOW_ruleCommunity_in_rule__Community__ChildrenAssignment_2_2_12787);
            ruleCommunity();
            _fsp--;

             after(grammarAccess.getCommunityAccess().getChildrenCommunityParserRuleCall_2_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Community__ChildrenAssignment_2_2_1


 

    public static final BitSet FOLLOW_ruleSocialNetwork_in_entryRuleSocialNetwork61 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleSocialNetwork68 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__SocialNetwork__Group__0_in_ruleSocialNetwork94 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleSocialEntity_in_entryRuleSocialEntity121 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleSocialEntity128 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__SocialEntity__Alternatives_in_ruleSocialEntity154 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleAquaintance_in_entryRuleAquaintance181 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleAquaintance188 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Aquaintance__Group__0_in_ruleAquaintance214 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rulePerson_in_entryRulePerson241 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRulePerson248 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group__0_in_rulePerson274 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleCommunity_in_entryRuleCommunity301 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleCommunity308 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Community__Group__0_in_ruleCommunity334 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__AquaintanceType__Alternatives_in_ruleAquaintanceType371 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Sex__Alternatives_in_ruleSex407 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rulePerson_in_rule__SocialEntity__Alternatives442 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleCommunity_in_rule__SocialEntity__Alternatives459 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_11_in_rule__AquaintanceType__Alternatives492 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_12_in_rule__AquaintanceType__Alternatives513 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_13_in_rule__Sex__Alternatives549 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_14_in_rule__Sex__Alternatives570 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__SocialNetwork__Group__0__Impl_in_rule__SocialNetwork__Group__0603 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_rule__SocialNetwork__Group__1_in_rule__SocialNetwork__Group__0606 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_15_in_rule__SocialNetwork__Group__0__Impl634 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__SocialNetwork__Group__1__Impl_in_rule__SocialNetwork__Group__1665 = new BitSet(new long[]{0x00000000004A0010L});
    public static final BitSet FOLLOW_rule__SocialNetwork__Group__2_in_rule__SocialNetwork__Group__1668 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_16_in_rule__SocialNetwork__Group__1__Impl696 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__SocialNetwork__Group__2__Impl_in_rule__SocialNetwork__Group__2727 = new BitSet(new long[]{0x0000000000020010L});
    public static final BitSet FOLLOW_rule__SocialNetwork__Group__3_in_rule__SocialNetwork__Group__2730 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__SocialNetwork__EntitiesAssignment_2_in_rule__SocialNetwork__Group__2__Impl757 = new BitSet(new long[]{0x0000000000480002L});
    public static final BitSet FOLLOW_rule__SocialNetwork__Group__3__Impl_in_rule__SocialNetwork__Group__3788 = new BitSet(new long[]{0x0000000000020000L});
    public static final BitSet FOLLOW_rule__SocialNetwork__Group__4_in_rule__SocialNetwork__Group__3791 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__SocialNetwork__AquaintancesAssignment_3_in_rule__SocialNetwork__Group__3__Impl818 = new BitSet(new long[]{0x0000000000000012L});
    public static final BitSet FOLLOW_rule__SocialNetwork__Group__4__Impl_in_rule__SocialNetwork__Group__4849 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_17_in_rule__SocialNetwork__Group__4__Impl877 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Aquaintance__Group__0__Impl_in_rule__Aquaintance__Group__0918 = new BitSet(new long[]{0x0000000000040000L});
    public static final BitSet FOLLOW_rule__Aquaintance__Group__1_in_rule__Aquaintance__Group__0921 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Aquaintance__SourceAssignment_0_in_rule__Aquaintance__Group__0__Impl948 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Aquaintance__Group__1__Impl_in_rule__Aquaintance__Group__1978 = new BitSet(new long[]{0x0000000000001800L});
    public static final BitSet FOLLOW_rule__Aquaintance__Group__2_in_rule__Aquaintance__Group__1981 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_18_in_rule__Aquaintance__Group__1__Impl1009 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Aquaintance__Group__2__Impl_in_rule__Aquaintance__Group__21040 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_rule__Aquaintance__Group__3_in_rule__Aquaintance__Group__21043 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Aquaintance__TypeAssignment_2_in_rule__Aquaintance__Group__2__Impl1070 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Aquaintance__Group__3__Impl_in_rule__Aquaintance__Group__31100 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Aquaintance__TargetAssignment_3_in_rule__Aquaintance__Group__3__Impl1127 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group__0__Impl_in_rule__Person__Group__01165 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_rule__Person__Group__1_in_rule__Person__Group__01168 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_19_in_rule__Person__Group__0__Impl1196 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group__1__Impl_in_rule__Person__Group__11227 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_rule__Person__Group__2_in_rule__Person__Group__11230 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__NameAssignment_1_in_rule__Person__Group__1__Impl1257 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group__2__Impl_in_rule__Person__Group__21287 = new BitSet(new long[]{0x0000000000006000L});
    public static final BitSet FOLLOW_rule__Person__Group__3_in_rule__Person__Group__21290 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_16_in_rule__Person__Group__2__Impl1318 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group__3__Impl_in_rule__Person__Group__31349 = new BitSet(new long[]{0x0000000000120000L});
    public static final BitSet FOLLOW_rule__Person__Group__4_in_rule__Person__Group__31352 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__SexAssignment_3_in_rule__Person__Group__3__Impl1379 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group__4__Impl_in_rule__Person__Group__41409 = new BitSet(new long[]{0x0000000000020000L});
    public static final BitSet FOLLOW_rule__Person__Group__5_in_rule__Person__Group__41412 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group_4__0_in_rule__Person__Group__4__Impl1439 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group__5__Impl_in_rule__Person__Group__51470 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_17_in_rule__Person__Group__5__Impl1498 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group_4__0__Impl_in_rule__Person__Group_4__01541 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_rule__Person__Group_4__1_in_rule__Person__Group_4__01544 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_20_in_rule__Person__Group_4__0__Impl1572 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group_4__1__Impl_in_rule__Person__Group_4__11603 = new BitSet(new long[]{0x0000000000200002L});
    public static final BitSet FOLLOW_rule__Person__Group_4__2_in_rule__Person__Group_4__11606 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__MembershipAssignment_4_1_in_rule__Person__Group_4__1__Impl1633 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group_4__2__Impl_in_rule__Person__Group_4__21663 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group_4_2__0_in_rule__Person__Group_4__2__Impl1690 = new BitSet(new long[]{0x0000000000200002L});
    public static final BitSet FOLLOW_rule__Person__Group_4_2__0__Impl_in_rule__Person__Group_4_2__01727 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_rule__Person__Group_4_2__1_in_rule__Person__Group_4_2__01730 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_21_in_rule__Person__Group_4_2__0__Impl1758 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group_4_2__1__Impl_in_rule__Person__Group_4_2__11789 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__MembershipAssignment_4_2_1_in_rule__Person__Group_4_2__1__Impl1816 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Community__Group__0__Impl_in_rule__Community__Group__01850 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_rule__Community__Group__1_in_rule__Community__Group__01853 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_22_in_rule__Community__Group__0__Impl1881 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Community__Group__1__Impl_in_rule__Community__Group__11912 = new BitSet(new long[]{0x0000000000010002L});
    public static final BitSet FOLLOW_rule__Community__Group__2_in_rule__Community__Group__11915 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Community__NameAssignment_1_in_rule__Community__Group__1__Impl1942 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Community__Group__2__Impl_in_rule__Community__Group__21972 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Community__Group_2__0_in_rule__Community__Group__2__Impl1999 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Community__Group_2__0__Impl_in_rule__Community__Group_2__02036 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_rule__Community__Group_2__1_in_rule__Community__Group_2__02039 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_16_in_rule__Community__Group_2__0__Impl2067 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Community__Group_2__1__Impl_in_rule__Community__Group_2__12098 = new BitSet(new long[]{0x0000000000220000L});
    public static final BitSet FOLLOW_rule__Community__Group_2__2_in_rule__Community__Group_2__12101 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Community__ChildrenAssignment_2_1_in_rule__Community__Group_2__1__Impl2128 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Community__Group_2__2__Impl_in_rule__Community__Group_2__22158 = new BitSet(new long[]{0x0000000000020000L});
    public static final BitSet FOLLOW_rule__Community__Group_2__3_in_rule__Community__Group_2__22161 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Community__Group_2_2__0_in_rule__Community__Group_2__2__Impl2188 = new BitSet(new long[]{0x0000000000200002L});
    public static final BitSet FOLLOW_rule__Community__Group_2__3__Impl_in_rule__Community__Group_2__32219 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_17_in_rule__Community__Group_2__3__Impl2247 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Community__Group_2_2__0__Impl_in_rule__Community__Group_2_2__02286 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_rule__Community__Group_2_2__1_in_rule__Community__Group_2_2__02289 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_21_in_rule__Community__Group_2_2__0__Impl2317 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Community__Group_2_2__1__Impl_in_rule__Community__Group_2_2__12348 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Community__ChildrenAssignment_2_2_1_in_rule__Community__Group_2_2__1__Impl2375 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleSocialEntity_in_rule__SocialNetwork__EntitiesAssignment_22414 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleAquaintance_in_rule__SocialNetwork__AquaintancesAssignment_32445 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RULE_ID_in_rule__Aquaintance__SourceAssignment_02480 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleAquaintanceType_in_rule__Aquaintance__TypeAssignment_22515 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RULE_ID_in_rule__Aquaintance__TargetAssignment_32550 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RULE_ID_in_rule__Person__NameAssignment_12585 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleSex_in_rule__Person__SexAssignment_32616 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RULE_ID_in_rule__Person__MembershipAssignment_4_12651 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RULE_ID_in_rule__Person__MembershipAssignment_4_2_12690 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RULE_ID_in_rule__Community__NameAssignment_12725 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleCommunity_in_rule__Community__ChildrenAssignment_2_12756 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleCommunity_in_rule__Community__ChildrenAssignment_2_2_12787 = new BitSet(new long[]{0x0000000000000002L});

}