package hu.bme.mit.parser.antlr.internal; 

import java.io.InputStream;
import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.xtext.parsetree.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.common.util.Enumerator;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import org.eclipse.xtext.conversion.ValueConverterException;
import hu.bme.mit.services.SocialnetworkGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalSocialnetworkParser extends AbstractInternalAntlrParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_ID", "RULE_INT", "RULE_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'SocialNetwork'", "'{'", "'}'", "'is'", "'Person'", "'memberships'", "','", "'Community'", "'friend of'", "'married to'", "'male'", "'female'"
    };
    public static final int RULE_ID=4;
    public static final int RULE_STRING=6;
    public static final int RULE_ANY_OTHER=10;
    public static final int RULE_INT=5;
    public static final int RULE_WS=9;
    public static final int RULE_SL_COMMENT=8;
    public static final int EOF=-1;
    public static final int RULE_ML_COMMENT=7;

        public InternalSocialnetworkParser(TokenStream input) {
            super(input);
        }
        

    public String[] getTokenNames() { return tokenNames; }
    public String getGrammarFileName() { return "../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g"; }



     	private SocialnetworkGrammarAccess grammarAccess;
     	
        public InternalSocialnetworkParser(TokenStream input, IAstFactory factory, SocialnetworkGrammarAccess grammarAccess) {
            this(input);
            this.factory = factory;
            registerRules(grammarAccess.getGrammar());
            this.grammarAccess = grammarAccess;
        }
        
        @Override
        protected InputStream getTokenFile() {
        	ClassLoader classLoader = getClass().getClassLoader();
        	return classLoader.getResourceAsStream("hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.tokens");
        }
        
        @Override
        protected String getFirstRuleName() {
        	return "SocialNetwork";	
       	}
       	
       	@Override
       	protected SocialnetworkGrammarAccess getGrammarAccess() {
       		return grammarAccess;
       	}



    // $ANTLR start entryRuleSocialNetwork
    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:78:1: entryRuleSocialNetwork returns [EObject current=null] : iv_ruleSocialNetwork= ruleSocialNetwork EOF ;
    public final EObject entryRuleSocialNetwork() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleSocialNetwork = null;


        try {
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:79:2: (iv_ruleSocialNetwork= ruleSocialNetwork EOF )
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:80:2: iv_ruleSocialNetwork= ruleSocialNetwork EOF
            {
             currentNode = createCompositeNode(grammarAccess.getSocialNetworkRule(), currentNode); 
            pushFollow(FOLLOW_ruleSocialNetwork_in_entryRuleSocialNetwork75);
            iv_ruleSocialNetwork=ruleSocialNetwork();
            _fsp--;

             current =iv_ruleSocialNetwork; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleSocialNetwork85); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end entryRuleSocialNetwork


    // $ANTLR start ruleSocialNetwork
    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:87:1: ruleSocialNetwork returns [EObject current=null] : ( 'SocialNetwork' '{' ( (lv_entities_2_0= ruleSocialEntity ) )* ( (lv_aquaintances_3_0= ruleAquaintance ) )* '}' ) ;
    public final EObject ruleSocialNetwork() throws RecognitionException {
        EObject current = null;

        EObject lv_entities_2_0 = null;

        EObject lv_aquaintances_3_0 = null;


         EObject temp=null; setCurrentLookahead(); resetLookahead(); 
            
        try {
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:92:6: ( ( 'SocialNetwork' '{' ( (lv_entities_2_0= ruleSocialEntity ) )* ( (lv_aquaintances_3_0= ruleAquaintance ) )* '}' ) )
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:93:1: ( 'SocialNetwork' '{' ( (lv_entities_2_0= ruleSocialEntity ) )* ( (lv_aquaintances_3_0= ruleAquaintance ) )* '}' )
            {
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:93:1: ( 'SocialNetwork' '{' ( (lv_entities_2_0= ruleSocialEntity ) )* ( (lv_aquaintances_3_0= ruleAquaintance ) )* '}' )
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:93:3: 'SocialNetwork' '{' ( (lv_entities_2_0= ruleSocialEntity ) )* ( (lv_aquaintances_3_0= ruleAquaintance ) )* '}'
            {
            match(input,11,FOLLOW_11_in_ruleSocialNetwork120); 

                    createLeafNode(grammarAccess.getSocialNetworkAccess().getSocialNetworkKeyword_0(), null); 
                
            match(input,12,FOLLOW_12_in_ruleSocialNetwork130); 

                    createLeafNode(grammarAccess.getSocialNetworkAccess().getLeftCurlyBracketKeyword_1(), null); 
                
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:101:1: ( (lv_entities_2_0= ruleSocialEntity ) )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==15||LA1_0==18) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:102:1: (lv_entities_2_0= ruleSocialEntity )
            	    {
            	    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:102:1: (lv_entities_2_0= ruleSocialEntity )
            	    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:103:3: lv_entities_2_0= ruleSocialEntity
            	    {
            	     
            	    	        currentNode=createCompositeNode(grammarAccess.getSocialNetworkAccess().getEntitiesSocialEntityParserRuleCall_2_0(), currentNode); 
            	    	    
            	    pushFollow(FOLLOW_ruleSocialEntity_in_ruleSocialNetwork151);
            	    lv_entities_2_0=ruleSocialEntity();
            	    _fsp--;


            	    	        if (current==null) {
            	    	            current = factory.create(grammarAccess.getSocialNetworkRule().getType().getClassifier());
            	    	            associateNodeWithAstElement(currentNode.getParent(), current);
            	    	        }
            	    	        try {
            	    	       		add(
            	    	       			current, 
            	    	       			"entities",
            	    	        		lv_entities_2_0, 
            	    	        		"SocialEntity", 
            	    	        		currentNode);
            	    	        } catch (ValueConverterException vce) {
            	    				handleValueConverterException(vce);
            	    	        }
            	    	        currentNode = currentNode.getParent();
            	    	    

            	    }


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);

            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:125:3: ( (lv_aquaintances_3_0= ruleAquaintance ) )*
            loop2:
            do {
                int alt2=2;
                int LA2_0 = input.LA(1);

                if ( (LA2_0==RULE_ID) ) {
                    alt2=1;
                }


                switch (alt2) {
            	case 1 :
            	    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:126:1: (lv_aquaintances_3_0= ruleAquaintance )
            	    {
            	    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:126:1: (lv_aquaintances_3_0= ruleAquaintance )
            	    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:127:3: lv_aquaintances_3_0= ruleAquaintance
            	    {
            	     
            	    	        currentNode=createCompositeNode(grammarAccess.getSocialNetworkAccess().getAquaintancesAquaintanceParserRuleCall_3_0(), currentNode); 
            	    	    
            	    pushFollow(FOLLOW_ruleAquaintance_in_ruleSocialNetwork173);
            	    lv_aquaintances_3_0=ruleAquaintance();
            	    _fsp--;


            	    	        if (current==null) {
            	    	            current = factory.create(grammarAccess.getSocialNetworkRule().getType().getClassifier());
            	    	            associateNodeWithAstElement(currentNode.getParent(), current);
            	    	        }
            	    	        try {
            	    	       		add(
            	    	       			current, 
            	    	       			"aquaintances",
            	    	        		lv_aquaintances_3_0, 
            	    	        		"Aquaintance", 
            	    	        		currentNode);
            	    	        } catch (ValueConverterException vce) {
            	    				handleValueConverterException(vce);
            	    	        }
            	    	        currentNode = currentNode.getParent();
            	    	    

            	    }


            	    }
            	    break;

            	default :
            	    break loop2;
                }
            } while (true);

            match(input,13,FOLLOW_13_in_ruleSocialNetwork184); 

                    createLeafNode(grammarAccess.getSocialNetworkAccess().getRightCurlyBracketKeyword_4(), null); 
                

            }


            }

             resetLookahead(); 
                	lastConsumedNode = currentNode;
                
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end ruleSocialNetwork


    // $ANTLR start entryRuleSocialEntity
    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:161:1: entryRuleSocialEntity returns [EObject current=null] : iv_ruleSocialEntity= ruleSocialEntity EOF ;
    public final EObject entryRuleSocialEntity() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleSocialEntity = null;


        try {
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:162:2: (iv_ruleSocialEntity= ruleSocialEntity EOF )
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:163:2: iv_ruleSocialEntity= ruleSocialEntity EOF
            {
             currentNode = createCompositeNode(grammarAccess.getSocialEntityRule(), currentNode); 
            pushFollow(FOLLOW_ruleSocialEntity_in_entryRuleSocialEntity220);
            iv_ruleSocialEntity=ruleSocialEntity();
            _fsp--;

             current =iv_ruleSocialEntity; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleSocialEntity230); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end entryRuleSocialEntity


    // $ANTLR start ruleSocialEntity
    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:170:1: ruleSocialEntity returns [EObject current=null] : (this_Person_0= rulePerson | this_Community_1= ruleCommunity ) ;
    public final EObject ruleSocialEntity() throws RecognitionException {
        EObject current = null;

        EObject this_Person_0 = null;

        EObject this_Community_1 = null;


         EObject temp=null; setCurrentLookahead(); resetLookahead(); 
            
        try {
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:175:6: ( (this_Person_0= rulePerson | this_Community_1= ruleCommunity ) )
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:176:1: (this_Person_0= rulePerson | this_Community_1= ruleCommunity )
            {
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:176:1: (this_Person_0= rulePerson | this_Community_1= ruleCommunity )
            int alt3=2;
            int LA3_0 = input.LA(1);

            if ( (LA3_0==15) ) {
                alt3=1;
            }
            else if ( (LA3_0==18) ) {
                alt3=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("176:1: (this_Person_0= rulePerson | this_Community_1= ruleCommunity )", 3, 0, input);

                throw nvae;
            }
            switch (alt3) {
                case 1 :
                    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:177:5: this_Person_0= rulePerson
                    {
                     
                            currentNode=createCompositeNode(grammarAccess.getSocialEntityAccess().getPersonParserRuleCall_0(), currentNode); 
                        
                    pushFollow(FOLLOW_rulePerson_in_ruleSocialEntity277);
                    this_Person_0=rulePerson();
                    _fsp--;

                     
                            current = this_Person_0; 
                            currentNode = currentNode.getParent();
                        

                    }
                    break;
                case 2 :
                    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:187:5: this_Community_1= ruleCommunity
                    {
                     
                            currentNode=createCompositeNode(grammarAccess.getSocialEntityAccess().getCommunityParserRuleCall_1(), currentNode); 
                        
                    pushFollow(FOLLOW_ruleCommunity_in_ruleSocialEntity304);
                    this_Community_1=ruleCommunity();
                    _fsp--;

                     
                            current = this_Community_1; 
                            currentNode = currentNode.getParent();
                        

                    }
                    break;

            }


            }

             resetLookahead(); 
                	lastConsumedNode = currentNode;
                
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end ruleSocialEntity


    // $ANTLR start entryRuleAquaintance
    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:203:1: entryRuleAquaintance returns [EObject current=null] : iv_ruleAquaintance= ruleAquaintance EOF ;
    public final EObject entryRuleAquaintance() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleAquaintance = null;


        try {
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:204:2: (iv_ruleAquaintance= ruleAquaintance EOF )
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:205:2: iv_ruleAquaintance= ruleAquaintance EOF
            {
             currentNode = createCompositeNode(grammarAccess.getAquaintanceRule(), currentNode); 
            pushFollow(FOLLOW_ruleAquaintance_in_entryRuleAquaintance339);
            iv_ruleAquaintance=ruleAquaintance();
            _fsp--;

             current =iv_ruleAquaintance; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleAquaintance349); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end entryRuleAquaintance


    // $ANTLR start ruleAquaintance
    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:212:1: ruleAquaintance returns [EObject current=null] : ( ( ( RULE_ID ) ) 'is' ( (lv_type_2_0= ruleAquaintanceType ) ) ( ( RULE_ID ) ) ) ;
    public final EObject ruleAquaintance() throws RecognitionException {
        EObject current = null;

        Enumerator lv_type_2_0 = null;


         EObject temp=null; setCurrentLookahead(); resetLookahead(); 
            
        try {
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:217:6: ( ( ( ( RULE_ID ) ) 'is' ( (lv_type_2_0= ruleAquaintanceType ) ) ( ( RULE_ID ) ) ) )
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:218:1: ( ( ( RULE_ID ) ) 'is' ( (lv_type_2_0= ruleAquaintanceType ) ) ( ( RULE_ID ) ) )
            {
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:218:1: ( ( ( RULE_ID ) ) 'is' ( (lv_type_2_0= ruleAquaintanceType ) ) ( ( RULE_ID ) ) )
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:218:2: ( ( RULE_ID ) ) 'is' ( (lv_type_2_0= ruleAquaintanceType ) ) ( ( RULE_ID ) )
            {
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:218:2: ( ( RULE_ID ) )
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:219:1: ( RULE_ID )
            {
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:219:1: ( RULE_ID )
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:220:3: RULE_ID
            {

            			if (current==null) {
            	            current = factory.create(grammarAccess.getAquaintanceRule().getType().getClassifier());
            	            associateNodeWithAstElement(currentNode, current);
            	        }
                    
            match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleAquaintance392); 

            		createLeafNode(grammarAccess.getAquaintanceAccess().getSourcePersonCrossReference_0_0(), "source"); 
            	

            }


            }

            match(input,14,FOLLOW_14_in_ruleAquaintance402); 

                    createLeafNode(grammarAccess.getAquaintanceAccess().getIsKeyword_1(), null); 
                
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:236:1: ( (lv_type_2_0= ruleAquaintanceType ) )
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:237:1: (lv_type_2_0= ruleAquaintanceType )
            {
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:237:1: (lv_type_2_0= ruleAquaintanceType )
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:238:3: lv_type_2_0= ruleAquaintanceType
            {
             
            	        currentNode=createCompositeNode(grammarAccess.getAquaintanceAccess().getTypeAquaintanceTypeEnumRuleCall_2_0(), currentNode); 
            	    
            pushFollow(FOLLOW_ruleAquaintanceType_in_ruleAquaintance423);
            lv_type_2_0=ruleAquaintanceType();
            _fsp--;


            	        if (current==null) {
            	            current = factory.create(grammarAccess.getAquaintanceRule().getType().getClassifier());
            	            associateNodeWithAstElement(currentNode.getParent(), current);
            	        }
            	        try {
            	       		set(
            	       			current, 
            	       			"type",
            	        		lv_type_2_0, 
            	        		"AquaintanceType", 
            	        		currentNode);
            	        } catch (ValueConverterException vce) {
            				handleValueConverterException(vce);
            	        }
            	        currentNode = currentNode.getParent();
            	    

            }


            }

            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:260:2: ( ( RULE_ID ) )
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:261:1: ( RULE_ID )
            {
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:261:1: ( RULE_ID )
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:262:3: RULE_ID
            {

            			if (current==null) {
            	            current = factory.create(grammarAccess.getAquaintanceRule().getType().getClassifier());
            	            associateNodeWithAstElement(currentNode, current);
            	        }
                    
            match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleAquaintance441); 

            		createLeafNode(grammarAccess.getAquaintanceAccess().getTargetPersonCrossReference_3_0(), "target"); 
            	

            }


            }


            }


            }

             resetLookahead(); 
                	lastConsumedNode = currentNode;
                
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end ruleAquaintance


    // $ANTLR start entryRulePerson
    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:282:1: entryRulePerson returns [EObject current=null] : iv_rulePerson= rulePerson EOF ;
    public final EObject entryRulePerson() throws RecognitionException {
        EObject current = null;

        EObject iv_rulePerson = null;


        try {
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:283:2: (iv_rulePerson= rulePerson EOF )
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:284:2: iv_rulePerson= rulePerson EOF
            {
             currentNode = createCompositeNode(grammarAccess.getPersonRule(), currentNode); 
            pushFollow(FOLLOW_rulePerson_in_entryRulePerson477);
            iv_rulePerson=rulePerson();
            _fsp--;

             current =iv_rulePerson; 
            match(input,EOF,FOLLOW_EOF_in_entryRulePerson487); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end entryRulePerson


    // $ANTLR start rulePerson
    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:291:1: rulePerson returns [EObject current=null] : ( 'Person' ( (lv_name_1_0= RULE_ID ) ) '{' ( (lv_sex_3_0= ruleSex ) ) ( 'memberships' ( ( RULE_ID ) ) ( ',' ( ( RULE_ID ) ) )* )? '}' ) ;
    public final EObject rulePerson() throws RecognitionException {
        EObject current = null;

        Token lv_name_1_0=null;
        Enumerator lv_sex_3_0 = null;


         EObject temp=null; setCurrentLookahead(); resetLookahead(); 
            
        try {
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:296:6: ( ( 'Person' ( (lv_name_1_0= RULE_ID ) ) '{' ( (lv_sex_3_0= ruleSex ) ) ( 'memberships' ( ( RULE_ID ) ) ( ',' ( ( RULE_ID ) ) )* )? '}' ) )
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:297:1: ( 'Person' ( (lv_name_1_0= RULE_ID ) ) '{' ( (lv_sex_3_0= ruleSex ) ) ( 'memberships' ( ( RULE_ID ) ) ( ',' ( ( RULE_ID ) ) )* )? '}' )
            {
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:297:1: ( 'Person' ( (lv_name_1_0= RULE_ID ) ) '{' ( (lv_sex_3_0= ruleSex ) ) ( 'memberships' ( ( RULE_ID ) ) ( ',' ( ( RULE_ID ) ) )* )? '}' )
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:297:3: 'Person' ( (lv_name_1_0= RULE_ID ) ) '{' ( (lv_sex_3_0= ruleSex ) ) ( 'memberships' ( ( RULE_ID ) ) ( ',' ( ( RULE_ID ) ) )* )? '}'
            {
            match(input,15,FOLLOW_15_in_rulePerson522); 

                    createLeafNode(grammarAccess.getPersonAccess().getPersonKeyword_0(), null); 
                
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:301:1: ( (lv_name_1_0= RULE_ID ) )
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:302:1: (lv_name_1_0= RULE_ID )
            {
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:302:1: (lv_name_1_0= RULE_ID )
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:303:3: lv_name_1_0= RULE_ID
            {
            lv_name_1_0=(Token)input.LT(1);
            match(input,RULE_ID,FOLLOW_RULE_ID_in_rulePerson539); 

            			createLeafNode(grammarAccess.getPersonAccess().getNameIDTerminalRuleCall_1_0(), "name"); 
            		

            	        if (current==null) {
            	            current = factory.create(grammarAccess.getPersonRule().getType().getClassifier());
            	            associateNodeWithAstElement(currentNode, current);
            	        }
            	        try {
            	       		set(
            	       			current, 
            	       			"name",
            	        		lv_name_1_0, 
            	        		"ID", 
            	        		lastConsumedNode);
            	        } catch (ValueConverterException vce) {
            				handleValueConverterException(vce);
            	        }
            	    

            }


            }

            match(input,12,FOLLOW_12_in_rulePerson554); 

                    createLeafNode(grammarAccess.getPersonAccess().getLeftCurlyBracketKeyword_2(), null); 
                
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:329:1: ( (lv_sex_3_0= ruleSex ) )
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:330:1: (lv_sex_3_0= ruleSex )
            {
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:330:1: (lv_sex_3_0= ruleSex )
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:331:3: lv_sex_3_0= ruleSex
            {
             
            	        currentNode=createCompositeNode(grammarAccess.getPersonAccess().getSexSexEnumRuleCall_3_0(), currentNode); 
            	    
            pushFollow(FOLLOW_ruleSex_in_rulePerson575);
            lv_sex_3_0=ruleSex();
            _fsp--;


            	        if (current==null) {
            	            current = factory.create(grammarAccess.getPersonRule().getType().getClassifier());
            	            associateNodeWithAstElement(currentNode.getParent(), current);
            	        }
            	        try {
            	       		set(
            	       			current, 
            	       			"sex",
            	        		lv_sex_3_0, 
            	        		"Sex", 
            	        		currentNode);
            	        } catch (ValueConverterException vce) {
            				handleValueConverterException(vce);
            	        }
            	        currentNode = currentNode.getParent();
            	    

            }


            }

            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:353:2: ( 'memberships' ( ( RULE_ID ) ) ( ',' ( ( RULE_ID ) ) )* )?
            int alt5=2;
            int LA5_0 = input.LA(1);

            if ( (LA5_0==16) ) {
                alt5=1;
            }
            switch (alt5) {
                case 1 :
                    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:353:4: 'memberships' ( ( RULE_ID ) ) ( ',' ( ( RULE_ID ) ) )*
                    {
                    match(input,16,FOLLOW_16_in_rulePerson586); 

                            createLeafNode(grammarAccess.getPersonAccess().getMembershipsKeyword_4_0(), null); 
                        
                    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:357:1: ( ( RULE_ID ) )
                    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:358:1: ( RULE_ID )
                    {
                    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:358:1: ( RULE_ID )
                    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:359:3: RULE_ID
                    {

                    			if (current==null) {
                    	            current = factory.create(grammarAccess.getPersonRule().getType().getClassifier());
                    	            associateNodeWithAstElement(currentNode, current);
                    	        }
                            
                    match(input,RULE_ID,FOLLOW_RULE_ID_in_rulePerson604); 

                    		createLeafNode(grammarAccess.getPersonAccess().getMembershipCommunityCrossReference_4_1_0(), "membership"); 
                    	

                    }


                    }

                    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:371:2: ( ',' ( ( RULE_ID ) ) )*
                    loop4:
                    do {
                        int alt4=2;
                        int LA4_0 = input.LA(1);

                        if ( (LA4_0==17) ) {
                            alt4=1;
                        }


                        switch (alt4) {
                    	case 1 :
                    	    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:371:4: ',' ( ( RULE_ID ) )
                    	    {
                    	    match(input,17,FOLLOW_17_in_rulePerson615); 

                    	            createLeafNode(grammarAccess.getPersonAccess().getCommaKeyword_4_2_0(), null); 
                    	        
                    	    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:375:1: ( ( RULE_ID ) )
                    	    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:376:1: ( RULE_ID )
                    	    {
                    	    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:376:1: ( RULE_ID )
                    	    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:377:3: RULE_ID
                    	    {

                    	    			if (current==null) {
                    	    	            current = factory.create(grammarAccess.getPersonRule().getType().getClassifier());
                    	    	            associateNodeWithAstElement(currentNode, current);
                    	    	        }
                    	            
                    	    match(input,RULE_ID,FOLLOW_RULE_ID_in_rulePerson633); 

                    	    		createLeafNode(grammarAccess.getPersonAccess().getMembershipCommunityCrossReference_4_2_1_0(), "membership"); 
                    	    	

                    	    }


                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop4;
                        }
                    } while (true);


                    }
                    break;

            }

            match(input,13,FOLLOW_13_in_rulePerson647); 

                    createLeafNode(grammarAccess.getPersonAccess().getRightCurlyBracketKeyword_5(), null); 
                

            }


            }

             resetLookahead(); 
                	lastConsumedNode = currentNode;
                
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end rulePerson


    // $ANTLR start entryRuleCommunity
    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:401:1: entryRuleCommunity returns [EObject current=null] : iv_ruleCommunity= ruleCommunity EOF ;
    public final EObject entryRuleCommunity() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleCommunity = null;


        try {
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:402:2: (iv_ruleCommunity= ruleCommunity EOF )
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:403:2: iv_ruleCommunity= ruleCommunity EOF
            {
             currentNode = createCompositeNode(grammarAccess.getCommunityRule(), currentNode); 
            pushFollow(FOLLOW_ruleCommunity_in_entryRuleCommunity683);
            iv_ruleCommunity=ruleCommunity();
            _fsp--;

             current =iv_ruleCommunity; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleCommunity693); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end entryRuleCommunity


    // $ANTLR start ruleCommunity
    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:410:1: ruleCommunity returns [EObject current=null] : ( 'Community' ( (lv_name_1_0= RULE_ID ) ) ( '{' ( (lv_children_3_0= ruleCommunity ) ) ( ',' ( (lv_children_5_0= ruleCommunity ) ) )* '}' )? ) ;
    public final EObject ruleCommunity() throws RecognitionException {
        EObject current = null;

        Token lv_name_1_0=null;
        EObject lv_children_3_0 = null;

        EObject lv_children_5_0 = null;


         EObject temp=null; setCurrentLookahead(); resetLookahead(); 
            
        try {
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:415:6: ( ( 'Community' ( (lv_name_1_0= RULE_ID ) ) ( '{' ( (lv_children_3_0= ruleCommunity ) ) ( ',' ( (lv_children_5_0= ruleCommunity ) ) )* '}' )? ) )
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:416:1: ( 'Community' ( (lv_name_1_0= RULE_ID ) ) ( '{' ( (lv_children_3_0= ruleCommunity ) ) ( ',' ( (lv_children_5_0= ruleCommunity ) ) )* '}' )? )
            {
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:416:1: ( 'Community' ( (lv_name_1_0= RULE_ID ) ) ( '{' ( (lv_children_3_0= ruleCommunity ) ) ( ',' ( (lv_children_5_0= ruleCommunity ) ) )* '}' )? )
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:416:3: 'Community' ( (lv_name_1_0= RULE_ID ) ) ( '{' ( (lv_children_3_0= ruleCommunity ) ) ( ',' ( (lv_children_5_0= ruleCommunity ) ) )* '}' )?
            {
            match(input,18,FOLLOW_18_in_ruleCommunity728); 

                    createLeafNode(grammarAccess.getCommunityAccess().getCommunityKeyword_0(), null); 
                
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:420:1: ( (lv_name_1_0= RULE_ID ) )
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:421:1: (lv_name_1_0= RULE_ID )
            {
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:421:1: (lv_name_1_0= RULE_ID )
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:422:3: lv_name_1_0= RULE_ID
            {
            lv_name_1_0=(Token)input.LT(1);
            match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleCommunity745); 

            			createLeafNode(grammarAccess.getCommunityAccess().getNameIDTerminalRuleCall_1_0(), "name"); 
            		

            	        if (current==null) {
            	            current = factory.create(grammarAccess.getCommunityRule().getType().getClassifier());
            	            associateNodeWithAstElement(currentNode, current);
            	        }
            	        try {
            	       		set(
            	       			current, 
            	       			"name",
            	        		lv_name_1_0, 
            	        		"ID", 
            	        		lastConsumedNode);
            	        } catch (ValueConverterException vce) {
            				handleValueConverterException(vce);
            	        }
            	    

            }


            }

            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:444:2: ( '{' ( (lv_children_3_0= ruleCommunity ) ) ( ',' ( (lv_children_5_0= ruleCommunity ) ) )* '}' )?
            int alt7=2;
            int LA7_0 = input.LA(1);

            if ( (LA7_0==12) ) {
                alt7=1;
            }
            switch (alt7) {
                case 1 :
                    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:444:4: '{' ( (lv_children_3_0= ruleCommunity ) ) ( ',' ( (lv_children_5_0= ruleCommunity ) ) )* '}'
                    {
                    match(input,12,FOLLOW_12_in_ruleCommunity761); 

                            createLeafNode(grammarAccess.getCommunityAccess().getLeftCurlyBracketKeyword_2_0(), null); 
                        
                    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:448:1: ( (lv_children_3_0= ruleCommunity ) )
                    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:449:1: (lv_children_3_0= ruleCommunity )
                    {
                    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:449:1: (lv_children_3_0= ruleCommunity )
                    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:450:3: lv_children_3_0= ruleCommunity
                    {
                     
                    	        currentNode=createCompositeNode(grammarAccess.getCommunityAccess().getChildrenCommunityParserRuleCall_2_1_0(), currentNode); 
                    	    
                    pushFollow(FOLLOW_ruleCommunity_in_ruleCommunity782);
                    lv_children_3_0=ruleCommunity();
                    _fsp--;


                    	        if (current==null) {
                    	            current = factory.create(grammarAccess.getCommunityRule().getType().getClassifier());
                    	            associateNodeWithAstElement(currentNode.getParent(), current);
                    	        }
                    	        try {
                    	       		add(
                    	       			current, 
                    	       			"children",
                    	        		lv_children_3_0, 
                    	        		"Community", 
                    	        		currentNode);
                    	        } catch (ValueConverterException vce) {
                    				handleValueConverterException(vce);
                    	        }
                    	        currentNode = currentNode.getParent();
                    	    

                    }


                    }

                    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:472:2: ( ',' ( (lv_children_5_0= ruleCommunity ) ) )*
                    loop6:
                    do {
                        int alt6=2;
                        int LA6_0 = input.LA(1);

                        if ( (LA6_0==17) ) {
                            alt6=1;
                        }


                        switch (alt6) {
                    	case 1 :
                    	    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:472:4: ',' ( (lv_children_5_0= ruleCommunity ) )
                    	    {
                    	    match(input,17,FOLLOW_17_in_ruleCommunity793); 

                    	            createLeafNode(grammarAccess.getCommunityAccess().getCommaKeyword_2_2_0(), null); 
                    	        
                    	    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:476:1: ( (lv_children_5_0= ruleCommunity ) )
                    	    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:477:1: (lv_children_5_0= ruleCommunity )
                    	    {
                    	    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:477:1: (lv_children_5_0= ruleCommunity )
                    	    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:478:3: lv_children_5_0= ruleCommunity
                    	    {
                    	     
                    	    	        currentNode=createCompositeNode(grammarAccess.getCommunityAccess().getChildrenCommunityParserRuleCall_2_2_1_0(), currentNode); 
                    	    	    
                    	    pushFollow(FOLLOW_ruleCommunity_in_ruleCommunity814);
                    	    lv_children_5_0=ruleCommunity();
                    	    _fsp--;


                    	    	        if (current==null) {
                    	    	            current = factory.create(grammarAccess.getCommunityRule().getType().getClassifier());
                    	    	            associateNodeWithAstElement(currentNode.getParent(), current);
                    	    	        }
                    	    	        try {
                    	    	       		add(
                    	    	       			current, 
                    	    	       			"children",
                    	    	        		lv_children_5_0, 
                    	    	        		"Community", 
                    	    	        		currentNode);
                    	    	        } catch (ValueConverterException vce) {
                    	    				handleValueConverterException(vce);
                    	    	        }
                    	    	        currentNode = currentNode.getParent();
                    	    	    

                    	    }


                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop6;
                        }
                    } while (true);

                    match(input,13,FOLLOW_13_in_ruleCommunity826); 

                            createLeafNode(grammarAccess.getCommunityAccess().getRightCurlyBracketKeyword_2_3(), null); 
                        

                    }
                    break;

            }


            }


            }

             resetLookahead(); 
                	lastConsumedNode = currentNode;
                
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end ruleCommunity


    // $ANTLR start ruleAquaintanceType
    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:512:1: ruleAquaintanceType returns [Enumerator current=null] : ( ( 'friend of' ) | ( 'married to' ) ) ;
    public final Enumerator ruleAquaintanceType() throws RecognitionException {
        Enumerator current = null;

         setCurrentLookahead(); resetLookahead(); 
        try {
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:516:6: ( ( ( 'friend of' ) | ( 'married to' ) ) )
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:517:1: ( ( 'friend of' ) | ( 'married to' ) )
            {
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:517:1: ( ( 'friend of' ) | ( 'married to' ) )
            int alt8=2;
            int LA8_0 = input.LA(1);

            if ( (LA8_0==19) ) {
                alt8=1;
            }
            else if ( (LA8_0==20) ) {
                alt8=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("517:1: ( ( 'friend of' ) | ( 'married to' ) )", 8, 0, input);

                throw nvae;
            }
            switch (alt8) {
                case 1 :
                    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:517:2: ( 'friend of' )
                    {
                    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:517:2: ( 'friend of' )
                    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:517:4: 'friend of'
                    {
                    match(input,19,FOLLOW_19_in_ruleAquaintanceType876); 

                            current = grammarAccess.getAquaintanceTypeAccess().getFriendshipEnumLiteralDeclaration_0().getEnumLiteral().getInstance();
                            createLeafNode(grammarAccess.getAquaintanceTypeAccess().getFriendshipEnumLiteralDeclaration_0(), null); 
                        

                    }


                    }
                    break;
                case 2 :
                    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:523:6: ( 'married to' )
                    {
                    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:523:6: ( 'married to' )
                    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:523:8: 'married to'
                    {
                    match(input,20,FOLLOW_20_in_ruleAquaintanceType891); 

                            current = grammarAccess.getAquaintanceTypeAccess().getMarriageEnumLiteralDeclaration_1().getEnumLiteral().getInstance();
                            createLeafNode(grammarAccess.getAquaintanceTypeAccess().getMarriageEnumLiteralDeclaration_1(), null); 
                        

                    }


                    }
                    break;

            }


            }

             resetLookahead(); 
                	lastConsumedNode = currentNode;
                
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end ruleAquaintanceType


    // $ANTLR start ruleSex
    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:533:1: ruleSex returns [Enumerator current=null] : ( ( 'male' ) | ( 'female' ) ) ;
    public final Enumerator ruleSex() throws RecognitionException {
        Enumerator current = null;

         setCurrentLookahead(); resetLookahead(); 
        try {
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:537:6: ( ( ( 'male' ) | ( 'female' ) ) )
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:538:1: ( ( 'male' ) | ( 'female' ) )
            {
            // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:538:1: ( ( 'male' ) | ( 'female' ) )
            int alt9=2;
            int LA9_0 = input.LA(1);

            if ( (LA9_0==21) ) {
                alt9=1;
            }
            else if ( (LA9_0==22) ) {
                alt9=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("538:1: ( ( 'male' ) | ( 'female' ) )", 9, 0, input);

                throw nvae;
            }
            switch (alt9) {
                case 1 :
                    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:538:2: ( 'male' )
                    {
                    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:538:2: ( 'male' )
                    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:538:4: 'male'
                    {
                    match(input,21,FOLLOW_21_in_ruleSex934); 

                            current = grammarAccess.getSexAccess().getMaleEnumLiteralDeclaration_0().getEnumLiteral().getInstance();
                            createLeafNode(grammarAccess.getSexAccess().getMaleEnumLiteralDeclaration_0(), null); 
                        

                    }


                    }
                    break;
                case 2 :
                    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:544:6: ( 'female' )
                    {
                    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:544:6: ( 'female' )
                    // ../hu.bme.mit.socialnetwork.text/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialnetwork.g:544:8: 'female'
                    {
                    match(input,22,FOLLOW_22_in_ruleSex949); 

                            current = grammarAccess.getSexAccess().getFemaleEnumLiteralDeclaration_1().getEnumLiteral().getInstance();
                            createLeafNode(grammarAccess.getSexAccess().getFemaleEnumLiteralDeclaration_1(), null); 
                        

                    }


                    }
                    break;

            }


            }

             resetLookahead(); 
                	lastConsumedNode = currentNode;
                
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end ruleSex


 

    public static final BitSet FOLLOW_ruleSocialNetwork_in_entryRuleSocialNetwork75 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleSocialNetwork85 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_11_in_ruleSocialNetwork120 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_12_in_ruleSocialNetwork130 = new BitSet(new long[]{0x000000000004A010L});
    public static final BitSet FOLLOW_ruleSocialEntity_in_ruleSocialNetwork151 = new BitSet(new long[]{0x000000000004A010L});
    public static final BitSet FOLLOW_ruleAquaintance_in_ruleSocialNetwork173 = new BitSet(new long[]{0x0000000000002010L});
    public static final BitSet FOLLOW_13_in_ruleSocialNetwork184 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleSocialEntity_in_entryRuleSocialEntity220 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleSocialEntity230 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rulePerson_in_ruleSocialEntity277 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleCommunity_in_ruleSocialEntity304 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleAquaintance_in_entryRuleAquaintance339 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleAquaintance349 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleAquaintance392 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_14_in_ruleAquaintance402 = new BitSet(new long[]{0x0000000000180000L});
    public static final BitSet FOLLOW_ruleAquaintanceType_in_ruleAquaintance423 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleAquaintance441 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rulePerson_in_entryRulePerson477 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRulePerson487 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_15_in_rulePerson522 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_rulePerson539 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_12_in_rulePerson554 = new BitSet(new long[]{0x0000000000600000L});
    public static final BitSet FOLLOW_ruleSex_in_rulePerson575 = new BitSet(new long[]{0x0000000000012000L});
    public static final BitSet FOLLOW_16_in_rulePerson586 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_rulePerson604 = new BitSet(new long[]{0x0000000000022000L});
    public static final BitSet FOLLOW_17_in_rulePerson615 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_rulePerson633 = new BitSet(new long[]{0x0000000000022000L});
    public static final BitSet FOLLOW_13_in_rulePerson647 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleCommunity_in_entryRuleCommunity683 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleCommunity693 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_18_in_ruleCommunity728 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleCommunity745 = new BitSet(new long[]{0x0000000000001002L});
    public static final BitSet FOLLOW_12_in_ruleCommunity761 = new BitSet(new long[]{0x0000000000040000L});
    public static final BitSet FOLLOW_ruleCommunity_in_ruleCommunity782 = new BitSet(new long[]{0x0000000000022000L});
    public static final BitSet FOLLOW_17_in_ruleCommunity793 = new BitSet(new long[]{0x0000000000040000L});
    public static final BitSet FOLLOW_ruleCommunity_in_ruleCommunity814 = new BitSet(new long[]{0x0000000000022000L});
    public static final BitSet FOLLOW_13_in_ruleCommunity826 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_19_in_ruleAquaintanceType876 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_20_in_ruleAquaintanceType891 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_21_in_ruleSex934 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_22_in_ruleSex949 = new BitSet(new long[]{0x0000000000000002L});

}